DECLARE
v1 int;
vUser_SID INTEGER := BLV_SYS.GET_USER_SID;
vFM CONSTANT VARCHAR2(100) := 'Der Betrieb enthlt fehlerhafte Daten, deshalb ist die automatische Bereinigung nicht mglich.';
BUFFER_TOO_SMALL EXCEPTION;
PRAGMA EXCEPTION_INIT(BUFFER_TOO_SMALL, -6502);

PROCEDURE INSERT_WKD_BEA(pD0101_ID IN VARCHAR2, pMandant IN INTEGER, pA0101_03_sid0 IN INTEGER) AS
vWKD_BEA wkd_bea%ROWTYPE;
BEGIN

  UPDATE wkd_bea
  SET result = -1
  , result_msg = vFM
  , a0101_03_sid0 = pA0101_03_sid0 
  WHERE d0101_id = pD0101_ID;
    
  IF SQL%ROWCOUNT = 0 THEN  
    vWKD_BEA.ID := SYS_GUID();
    vWKD_BEA.ins_date := SYSDATE;
    vWKD_BEA.ins_user := vUser_SID;
    vWKD_BEA.d0101_id := pD0101_ID;
    
    -- mit Werten aus D0101 aktualisieren
    vWKD_BEA.mandant := pMandant;
    vWKD_BEA.upd_date := SYSDATE;
    vWKD_BEA.upd_user := vUser_SID;
    vWKD_BEA.deleted := 0;
    vWKD_BEA.result := -1;
    vWKD_BEA.a0101_03_sid0 := pA0101_03_SID0;
    vWKD_BEA.result_msg := vFM;
    INSERT INTO wkd_bea VALUES vWKD_BEA;
  END IF;  
END;


BEGIN
  
  SELECT COUNT(*) INTO v1
  FROM VIS_S00 WHERE LOWER(PARAMS) LIKE '%notebook_repli_server=0%';

  IF v1 = 0 THEN -- nur auf dem Server ausfhren
    -- fr alle BEA-Betriebe Eintrge in wkd_bea als OK aktualisieren
    UPDATE wkd_bea
    SET result = 1
      , upd_date = SYSDATE
    WHERE result <> 1
    AND d0101_id IN ( SELECT d0101.id FROM vis_d0101 d0101 WHERE d0101.daten_herkunft = 'BEA');
    COMMIT;  

    FOR c1 IN (
      SELECT id, mandant, a0101_03_sid, ROWNUM row_num 
      FROM vis_d0101 
      WHERE deleted = 0
      AND skz IN (1,98,99)
      AND id NOT IN ('-1', '-2')
      AND NVL(daten_herkunft,'x') <> 'BEA' -- neue Anforderung 20.05.2014
      ORDER BY CASE WHEN id = d0101_id3 THEN 0 ELSE 1 END
    ) LOOP
      BEGIN
        v1 := blv_prepair_bea.CheckD0101(c1.id);
      
        EXCEPTION
        WHEN BUFFER_TOO_SMALL THEN
          --DBMS_OUTPUT.PUT_LINE(c1.id); 
          INSERT_WKD_BEA(c1.id, c1.mandant, c1.a0101_03_sid);   
      END;          
      
      IF MOD(c1.row_num, 500) = 0 THEN
        COMMIT;
      END IF;
    END LOOP;
    COMMIT;
  END IF;
END;