/*<TOAD_FILE_CHUNK>*/

ALTER SESSION SET PLSQL_CODE_TYPE = NATIVE;
--ALTER SESSION SET PLSQL_CODE_TYPE = INTERPRETED;
/

ALTER SESSION SET PLSQL_OPTIMIZE_LEVEL = 3;
/

--alter session set plsql_warnings = 'Enable:All', 'Disable:(6002, 6003, 6006, 6005)'; 
--alter session set plsql_warnings = 'Disable:All'; 

--SET DEFINE OFF
--Abschalten der COMMIT mit folgender Anweisung mglich
--ALTER SESSION SET plsql_ccflags = 'BLV_DEBUG:TRUE';
--oder
--ALTER PACKAGE BLV_PREPAIR_BEA COMPILE BODY plsql_ccflags = 'BLV_DEBUG:TRUE'; 
CREATE OR REPLACE PACKAGE BLV_PREPAIR_BEA AS  

FUNCTION Version RETURN VARCHAR2; 
--FUNCTION Test(pD0101_ID IN vis_d0101.id%TYPE) RETURN VARCHAR2;  
FUNCTION D0101IsChecked(pD0101_ID IN vis_d0101.id%TYPE, pCheck IN NUMBER := 0) RETURN NUMBER;
FUNCTION D0101CheckResult(pD0101_ID IN vis_d0101.id%TYPE, pCheck IN NUMBER := 0) RETURN NUMBER;
FUNCTION D0101CheckMsg(pD0101_ID IN vis_d0101.id%TYPE) RETURN CLOB;
FUNCTION CheckD0101(pD0101_ID IN vis_d0101.id%TYPE, pInsert NUMBER := 0) RETURN NUMBER;
PROCEDURE RepairD0101(pD0101_ID IN vis_d0101.id%TYPE, pBatch IN INT := 0);
FUNCTION RepairD0101ErrCount RETURN NUMBER;
FUNCTION RepairD0101Msg RETURN VARCHAR2;
--FUNCTION NamenZusatzEntfernen( pBez IN VARCHAR2 ) RETURN VARCHAR2;

PROCEDURE SplitOperator(pD0101_ID IN vis_d0101.id%TYPE, pBatch IN INT := 0);
FUNCTION CreateD0102Bez( pAnrede IN VARCHAR2, pTitel IN VARCHAR2,pVname IN VARCHAR2, pNname IN VARCHAR2,  pVorsatz IN VARCHAR2, pNachsatz IN VARCHAR2) RETURN VARCHAR2;
FUNCTION CreateD0102Bez( pD0101 IN vis_d0101%ROWTYPE) RETURN VARCHAR2;

--FUNCTION ChkVNamen(pVnamen IN VARCHAR2, p2 IN INT := 1) RETURN INT;
--FUNCTION IsGleich( p1 IN VARCHAR2, p2 IN VARCHAR2, p3 IN VARCHAR2) RETURN VARCHAR2;
--FUNCTION AufbereitungResultMsg(pD0101 IN vis_d0101%ROWTYPE, pModus IN INT) RETURN VARCHAR2;
--FUNCTION D0101CheckMsg2(pD0101_ID IN vis_d0101.id%TYPE) RETURN CLOB;
--PROCEDURE CrtHit_bez(pBez IN vis_d0101.bez%TYPE, pHIT1 OUT vis_d0101.hit_bez_1%TYPE, pHIT2 OUT vis_d0101.hit_bez_1%TYPE);
END;
/

/*<TOAD_FILE_CHUNK>*/
CREATE OR REPLACE PACKAGE BODY BLV_PREPAIR_BEA AS
  --vD0101 vis_d0101%ROWTYPE;   -- Betrieb
  --vD0101_3 vis_d0101%ROWTYPE; -- neuer Betreiber
  vWKD_BEA wkd_bea%ROWTYPE;
  
  vUser_SID INTEGER;
  vMandant_SID INTEGER;
  vBetreiber_ID CONSTANT VARCHAR2(10) := '01901302'; -- IDV-Betreiber ID
  vHIT_NR CONSTANT VARCHAR2(4) := '0102';  -- HIT-Nr.
  vInvekos_NR CONSTANT VARCHAR2(4) := '0118';
  CrLf CONSTANT VARCHAR2(2) := CHR(13)||CHR(10);
  vRepairErrCnt INT;
  vRepairMsg VARCHAR2(4000);
  vRegelMsg VARCHAR2(4000);
  vGKZ2_NRW CONSTANT VARCHAR2(2) := '05';
-- Generieren Bezeichnung: Nachname, Vorname Vorsatz, Nachsatz, Titel 
-- d0101.bez EinzelU
FUNCTION CreateD0101Bez(pnname IN VARCHAR2, pvname IN VARCHAR2,
                         pVorsatz IN VARCHAR2, pNachsatz  IN VARCHAR2, 
                         pTITEL IN VARCHAR2) RETURN VARCHAR2 AS
v1 VARCHAR2(450);
BEGIN
  v1 := Pnname ||
         CASE WHEN pvname || pVorsatz IS NOT NULL THEN  ', ' || TRIM(pvname || ' ' || pVorsatz) END || 
         CASE WHEN pNachsatz IS NOT NULL THEN  ', ' || pNachsatz END || 
         CASE WHEN pTITEL IS NOT NULL THEN ', ' || pTITEL END;
         
  IF LENGTH(v1) > 128 THEN
    v1 := SUBSTR(v1, 1, 126) || '..';
  END IF;
  
  RETURN v1;       
END;

FUNCTION CreateD0101Bez(pD0101 IN vis_d0101%ROWTYPE) RETURN VARCHAR2 AS
BEGIN
  RETURN CreateD0101Bez(
            pD0101.nname, pD0101.vname,
            pD0101.Vorsatz_nname, pD0101.Nachsatz_nname, 
            pD0101.TITEL);
END;

-- Ermittelt die Rechtsform fr den Betreiber2 anhand der bergebenen 
-- Rechtsform vom Betreibers1  
-- auch redundant in blv_ein enthalten
FUNCTION GetRechtsformBetreiber2(pA0101_03_sid IN INT) RETURN INT AS
  v1 INT := -1;
BEGIN
  CASE pA0101_03_sid  
  WHEN 643001 THEN -- 3001 Limited und Co.KG
    v1 := 642001;  -- 30 Limited
  WHEN 1151001 THEN -- GmbH und Co. OHG
    v1 := 4;  -- 03 GmbH
  WHEN 5 THEN -- 04 GmbH und Co. KG
    v1 := 4;   -- 03 GmbH
  WHEN 1219001 THEN -- 0302 UG (haftungsbeschrnkt) und Co. KG
    v1 := 1187001; -- 0301 UG (haftungsbeschrnkt)
  WHEN 2539001 THEN -- 1403 AG und Co. KG
    v1 := 3;        -- 02 AG
  WHEN 2538001 THEN -- 1402 Stiftung und Co. KG
    v1 := 400001;   -- 23 Stiftung des privaten Rechts
  ELSE
    v1 := -1;
  END CASE;
  RETURN v1;
END;
  
-- Bezeichnung generierien: Anrede Titel Vorname Vorsatz Nachname, Nachsatz  
-- Verwendung fr d0102.bez und d010200.bez
FUNCTION CreateD0102Bez( pAnrede IN VARCHAR2, pTitel IN VARCHAR2,pVname IN VARCHAR2, pNname IN VARCHAR2,  pVorsatz IN VARCHAR2, pNachsatz IN VARCHAR2) RETURN VARCHAR2 AS
 v1 VARCHAR2(450);
  PROCEDURE Add_v1( p1 IN VARCHAR2, p2 IN VARCHAR2) AS
  BEGIN
    IF p1 IS NOT NULL THEN
      IF v1 IS NULL THEN
        v1 := p1;
      ELSE
        v1 := TRIM(v1) || p2 || p1;
      END IF; 
    END IF;
  END;
BEGIN
  --v1 := pAnrede;
  v1 := pTitel;
  --Add_V1(TRIM(pTitel), ' ');
  Add_V1(TRIM(pVname), ' ');
  Add_V1(TRIM(pVorsatz), ' ');
  Add_V1(TRIM(pNname), ' ');
  Add_V1(TRIM(pNachsatz), ', ');
  
  IF LENGTH(v1) > 128 THEN
    v1 := SUBSTR(v1, 1, 126) || '..';
  END IF;
  RETURN v1;   
  
END;

FUNCTION CreateD0102Bez( pD0101 IN vis_d0101%ROWTYPE) RETURN VARCHAR2 AS
BEGIN
  RETURN CreateD0102Bez(pD0101.anrede, pD0101.titel, pD0101.vname, pD0101.nname, pD0101.vorsatz_nname, pD0101.nachsatz_nname); 
END;


FUNCTION GetRechtsformTyp(pA0101_03_SID IN INT) RETURN CHAR AS
vRes VARCHAR2(10 CHAR) := 'E';
BEGIN

  IF pA0101_03_SID > -1 THEN
    BEGIN
    
      SELECT feld1 INTO vRes FROM vis_a0101
      WHERE sid = pA0101_03_SID;

      vRes := TRIM(vRes);

      IF vRes = '0' THEN 
        vRes := 'N';
      ELSE
        vRes := 'F';
      END IF;
      
      EXCEPTION WHEN NO_DATA_FOUND THEN NULL;
      
    END;
  END IF;
  
  RETURN vRes;   
        
END;
 
-- Liefert zur Anrede die passende Briefanrede aus dem Katalog Anrede (a0101 skz = 7)
-- 19.09.2014 aus blv_ein bernommen
Function GetBriefanrede(pAnrede IN VARCHAR2) RETURN VARCHAR2 DETERMINISTIC AS
  v1 vis_a0101.bez%TYPE;
BEGIN

  BEGIN
    SELECT bez INTO v1
    FROM vis_a0101
    WHERE deleted = 0
    AND skz = 7
    AND kurzb = pAnrede;
    
    EXCEPTION 
    WHEN NO_DATA_FOUND THEN
      v1 := NULL;
    WHEN TOO_MANY_ROWS THEN
      v1 := NULL;
  END;
    
  RETURN v1;

END; 
PROCEDURE AddMsg(pMSG IN VARCHAR2, pIgnorNull BOOLEAN := FALSE) AS
BEGIN
  IF pMSG IS NULL AND pIgnorNull THEN
    NULL;
  ELSE
    IF vWKD_BEA.result_msg IS NOT NULL THEN
      vWKD_BEA.result_msg := vWKD_BEA.result_msg || CHR(13) || pMsg;
    ELSE
      vWKD_BEA.result_msg := pMsg;
    END IF;
 END IF;
END;

PROCEDURE AddMsgRegel(pMSG IN VARCHAR2) AS
BEGIN
--  IF vWKD_BEA.result_msg IS NOT NULL THEN
--    vWKD_BEA.result_msg := pMsg || CHR(13) || vWKD_BEA.result_msg;
--  ELSE
--    vWKD_BEA.result_msg := pMsg;
--  END IF;
  IF vRegelMsg IS NOT NULL THEN
    vRegelMsg := vRegelMsg || ' ' ||pMsg;
  ELSE
    vRegelMsg := pMsg;
  END IF;
END;


PROCEDURE ClearMsg AS 
BEGIN
  vWKD_BEA.Result_Msg := NULL;
  vRepairMsg := NULL;
  vRepairErrCnt := 0;
  vRegelMsg := NULL;
END;

-- Titel und Namensvorsatz und -Nachsatz entfernen
FUNCTION NamenZusatzEntfernen( pBez IN VARCHAR2 ) RETURN VARCHAR2 AS
  --v1 VARCHAR2(1000);
  vLen INT;
  vBez VARCHAR2(1000) := TRIM(pBez);

  -- Vorsatz (73) und Titel(8)
  CURSOR c1 ( p1 IN VARCHAR2) IS
     SELECT LENGTH(bez) 
     FROM vis_a0101
     WHERE skz IN (8, 73)
     AND deleted > -2
     AND p1 LIKE UPPER(bez) || ' %'
     ORDER BY LENGTH(bez) DESC;  

  -- Nachsatz(74)
  CURSOR c2 ( p1 IN VARCHAR2) IS
     SELECT LENGTH(bez) 
     FROM vis_a0101
     WHERE skz IN (74)
     AND deleted > -2
     AND p1 LIKE '% ' || UPPER(bez)
     ORDER BY LENGTH(bez) DESC;  


BEGIN
  -- Titel und Vorsatz
  OPEN c1 ( UPPER(vBez) );
  LOOP
    FETCH c1 INTO vLen;
    EXIT WHEN c1%NOTFOUND;
    vBez := TRIM( SUBSTR(vBez, vLen + 1) );
    CLOSE c1;
    OPEN c1( UPPER(vBez) );
  END LOOP;
  CLOSE c1;
  
  -- Nachsatz
  vBez := REPLACE(vBez, ' jun.', ' Junior');
  OPEN c2 ( UPPER(vBez) );
  LOOP
    FETCH c2 INTO vLen;
    EXIT WHEN c2%NOTFOUND;
    vBez := TRIM( SUBSTR(vBez, 1, LENGTH(vBez)- vLen) );
    CLOSE c2;
    OPEN c2( UPPER(vBez) );
  END LOOP;
  CLOSE c2;  
  
  RETURN vBez;
END;

FUNCTION ChkVNameGbR(p1 IN VARCHAR2) RETURN BOOLEAN AS
BEGIN
  RETURN INSTR(p1, ' und ') > 0 OR INSTR(p1, ' u. ') > 0 OR INSTR(p1, CHR(38)) > 0;
END;

FUNCTION BereinigungVName(p1 IN VARCHAR2) RETURN VARCHAR2 AS
BEGIN    
  RETURN REPLACE( REPLACE( REPLACE( REPLACE( p1, ' und ', ' '), ' u.', ' '), CHR(38), ' '), '-' , ' '); 
END;
-- berprfung alle Vornamen in pVNamen auf Gltigkeit in vis_a0081
-- p2 Steuerung ob alle Namen (1) oder einer als gltiger Vorname erkannt werden soll 
FUNCTION ChkVNamen(pVnamen IN VARCHAR2, p2 IN INT := 1) RETURN INT AS
vCnt INT;
vCnt_A0081 INT;
vRes INT;
BEGIN

  SELECT COUNT(*), COUNT(a0081.SID) INTO vCnt, vCnt_A0081
  FROM (
    SELECT REGEXP_SUBSTR(pVnamen, '[^ ]+', 1, LEVEL) txt 
    FROM dual
    CONNECT BY REGEXP_SUBSTR(pVnamen, '[^ ]+', 1, LEVEL) IS NOT NULL
  ) dx 
  LEFT JOIN vis_a0081 a0081 ON a0081.vname = dx.txt
  AND a0081.deleted = 0; 

  CASE
  WHEN p2 = 0 AND vCnt_A0081 > 0 THEN
    vRes := 1;
  WHEN p2 = 1 AND vCnt > 0 AND vCnt_A0081 = vCnt THEN
    vRes := 1;
  ELSE
    vRes := 0;
  END CASE;
  RETURN vRes;
END;

-- Vergleich p1 mit p2 in dem alle Teilstringe aus p1 in p2 enthalten sein mssen
-- wobei p2 noch zustzlich eine Anrede enthalten kann
-- die Reihenfolge der Teilstrings muss nicht gleich sein
-- sind p1 und p2 gleich wird p3 geliefert
-- 
FUNCTION IsGleich( p1 IN VARCHAR2, p2 IN VARCHAR2, p3 IN VARCHAR2) RETURN VARCHAR2 AS
vRes VARCHAR2(1000) := NULL;
v1 VARCHAR2(1000) := REPLACE(p1, ',', ' ');
v2 VARCHAR2(1000) := REPLACE(p2, ',', ' ');
v3 VARCHAR2(1000);
i INT := 1;
BEGIN

  IF p2 = p3 THEN
    vRes := p2;
  ELSE
    -- Namensteile entfernen
    LOOP
      v3 := dbo.get_token(v1, i, ' ');
      EXIT WHEN v3 IS NULL;
      i := i + 1;
      IF INSTR(v2, v3) > 0 THEN
        v2 := REPLACE(v2, v3, NULL);
      ELSE
        EXIT;
      END IF;    
    END LOOP;

    IF TRIM(v2) IS NOT NULL THEN

      SELECT COUNT(*) INTO i -- Anrede
      FROM vis_a0101
      WHERE skz = 7
      AND kurzb = TRIM(v2);
      
      IF i > 0 THEN
        vRes := p3;
      ELSE

        CASE
        WHEN p1 = p2 THEN
          vRes := p3;
        WHEN p2 IS NOT NULL AND p3 IS NOT NULL THEN
          vRes := p2|| ', ' || p3;
        WHEN p2 IS NOT NULL AND p3 IS NULL THEN
          vRes := p2;
        ELSE
          vRes := p3;  
        END CASE;
      END IF;
    ELSE
      vRes := p3;
    END IF;
  END IF;
  Return vRes;
END;

-- Personalfunhktionen anlegen
-- sind keine im Zuordnungskatalog dann einen leeren Datensatz anlegen
PROCEDURE InsertD010202(pA0101_03_SID IN INT, pD0101_ID IN VARCHAR2, pD010200_ID IN VARCHAR2) AS
vD010202 vis_d010202%ROWTYPE;
vExists INT := 0;
BEGIN

  -- Initialisierung
  SELECT * INTO vD010202
  FROM vis_d010202 WHERE id = '-1';
            
  vD010202.d010200_id := pD010200_id;
  vD010202.d0101_id   := pD0101_id;
  vD010202.MANDANT    := vMandant_SID; 
  vD010202.INS_USER   := vUser_SID;
  vD010202.INS_DATE   := SYSDATE;
  vD010202.UPD_USER   := vUser_SID;
  vD010202.UPD_DATE   := SYSDATE;
  vD010202.DELETED    := 0;
  vD010202.DEL_USER   := '-1';
  vD010202.DEL_DATE   := NULL;
  vD010202.d0103_id   := '-1';
  vD010202.zb         := '%';
  vD010202.fb         := '%';
  vD010202.az_prozent := 0;
  vD010202.vertreter  := NULL;
  vD010202.code       := NULL;
  vD010202.coden      := NULL;
  vD010202.bez        := NULL;

  FOR c1 IN ( 
    SELECT a0088.a0101_70_sid
    FROM vis_va0088$a0101_03$a0101_70 a0088
    WHERE a0088.a0101_03_sid = pA0101_03_sid
  ) LOOP

    vD010202.id         := SYS_GUID();
    vD010202.a0101_70_sid := NVL(c1.A0101_70_sid, -1);
    INSERT INTO vis_d010202 VALUES vD010202;
    $IF $$BLV_DEBUG $THEN
    $ELSE 
      COMMIT;
    $END
    
    vExists := 1;
    
  END LOOP;
   
  IF vExists = 0 THEN
    vD010202.id := SYS_GUID();
    vD010202.a0101_70_sid := -1;
    INSERT INTO vis_d010202 VALUES vD010202;
    $IF $$BLV_DEBUG $THEN
    $ELSE 
      COMMIT;
    $END
      
  END IF;
   
END;

-- Personal bei Einzelunternehmen bez_art = N
PROCEDURE Personal_N(pD0101 IN vis_d0101%ROWTYPE, pD0101_3 IN vis_d0101%ROWTYPE, pFallBerlin IN INT)  AS
vHV_Exists INT := 0;
vD0102 vis_d0102%ROWTYPE;
vD010200 vis_d010200%ROWTYPE;
vA0101_70_SID vis_a0101.sid%TYPE;
vCnt1 INT;

  PROCEDURE CreateHV AS
  BEGIN

    -- Initialisierung
    SELECT * INTO vD0102 FROM vis_d0102 WHERE id = '-1';
    SELECT * INTO vD010200 FROM vis_d010200 WHERE id = '-1';
    
    vD0102.id := SYS_GUID();
    vD0102.upd_date := SYSDATE;
    vD0102.upd_user := vUser_SID;
    vD0102.ins_date := SYSDATE;
    vD0102.ins_user := vUser_SID; 
    vD0102.mandant := vMandant_sid;   
    vD0102.deleted := 0;
    vD0102.nname := pD0101_3.nname;
    vD0102.vname := pD0101_3.vname;
    vD0102.vorsatz_nname := pD0101_3.vorsatz_nname;
    vD0102.nachsatz_nname := pD0101_3.nachsatz_nname;
    vD0102.titel := pD0101_3.titel;
    vD0102.anrede := pD0101_3.anrede;
    vD0102.briefanrede := GetBriefanrede(pD0101_3.anrede); -- 19.09.2014
    vD0102.bez := CreateD0102BEZ(pD0101_3.ANREDE, pD0101_3.TITEL, pD0101_3.VNAME, pD0101_3.NNAME, pD0101_3.VORSATZ_NNAME, pD0101_3.NACHSATZ_NNAME);  
  
    INSERT INTO vis_d0102 VALUES vD0102;
    $IF $$BLV_DEBUG $THEN
    $ELSE 
      COMMIT;
    $END
    
    vD010200.id := SYS_GUID();
    vD010200.upd_date := SYSDATE;
    vD010200.upd_user := vUser_SID;
    vD010200.ins_date := SYSDATE;
    vD010200.ins_user := vUser_SID;  
    vD010200.mandant := vMandant_sid;
    vD010200.deleted := 0;    
    vD010200.d0102_id := vD0102.id;
    vD010200.d0101_id := pD0101_3.id;
    vD010200.hauptansprechpartner := 1;
    vD010200.bez := vD0102.bez;
    vD010200.betriebspersonal := 1;
    vD010200.inhaber := 1;
    
    INSERT INTO vis_d010200 VALUES vD010200;
    $IF $$BLV_DEBUG $THEN
    $ELSE 
      COMMIT;
    $END
     
    IF pFallBerlin = 1 THEN -- Hauptansprechpartner in BTR setzen
      UPDATE vis_d0101
      SET d010200_id2 = vD010200.id
        , upd_date = SYSDATE
        , upd_user = vUser_SID
      WHERE id IN (pD0101_3.id);
    ELSE -- Hauptansprechpartner in BTR u. BTS setzen
      UPDATE vis_d0101
      SET d010200_id2 = vD010200.id
        , upd_date = SYSDATE
        , upd_user = vUser_SID
      WHERE id IN (pD0101.id, pD0101_3.id);
    END IF;
    
    InsertD010202(pD0101_3.A0101_03_SID, pD0101_3.ID, vD010200.ID);

    vD0102 := NULL;
    vD010200 := NULL; 
       
  END;
    
BEGIN

  IF pD0101_3.nname || pD0101_3.vname IS NULL THEN
    RETURN;
  END IF;
  FOR c1 IN (
    SELECT d010200.id 
    --, d0102.nname || d0102.vname || d0102.vorsatz_nname || d0102.nachsatz_nname komplett
    , D010200.HAUPTANSPRECHPARTNER
    FROM vis_d010200 d010200
    JOIN vis_d0102 d0102 ON d0102.id = d010200.d0102_id
    AND d010200.deleted = 0
    AND d010200.d0101_id = pD0101.id
    AND UPPER(REPLACE(REPLACE( d0102.nname || d0102.vname || d0102.vorsatz_nname || d0102.nachsatz_nname || CHR(9), '-', ' '), ',', ' ')) = 
        UPPER(REPLACE(REPLACE( pD0101_3.nname || pD0101_3.vname || pD0101_3.vorsatz_nname || pD0101_3.nachsatz_nname || CHR(9), '-', ' '), ',', ' '))
    --AND D010200.HAUPTANSPRECHPARTNER = 1
    ORDER BY D010200.HAUPTANSPRECHPARTNER NULLS LAST  -- 05.06.2014
  ) LOOP
 
    vHV_Exists := 1;      
    -- keine Abweichung
    -- Hauptansprechpartner bei Betrieb und Betreiber setzen, wenn nicht Fall Berlin
    IF c1.hauptansprechpartner = 1 AND pFallBerlin = 0 THEN
      UPDATE vis_d0101
      SET d010200_id2 = c1.id
        , upd_date = SYSDATE
        , upd_user = vUser_sid
      WHERE id IN( pD0101_3.id, pD0101.id);
    ELSE
      UPDATE vis_d0101
      SET d010200_id2 = c1.id
        , upd_date = SYSDATE
        , upd_user = vUser_sid
      WHERE id IN( pD0101_3.id);      
    END IF;      
    --Personal dem Betreiber zuordnen
    UPDATE vis_d010200
    SET d0101_ID = pD0101_3.id
      , hauptansprechpartner = 1
      , inhaber = 1 
      , betriebspersonal = 1
      , upd_date = SYSDATE
      , upd_user = vUser_sid
    WHERE id = c1.id;
         
    UPDATE vis_d010202 -- Personalfunktionen auf Betreiber bertragen
    SET d0101_id = pD0101_3.id
      , d0103_id = '-1'
      , upd_date = SYSDATE
      , upd_user = vUser_sid
    WHERE deleted = 0
    AND d010200_id = c1.id;

    IF SQL%ROWCOUNT = 0 THEN -- keine Personalfunktion vorhanden
      InsertD010202(pD0101_3.A0101_03_SID, pD0101_3.id, c1.id);
    ELSE -- Pesonalfunktion ist vorhanden, richtig gesetzt oder leer
      
      SELECT NVL(MAX(a0088.a0101_70_sid), -1)
      INTO vA0101_70_SID
      FROM vis_va0088$a0101_03$a0101_70 a0088
      WHERE a0088.a0101_03_sid = pD0101_3.A0101_03_sid;
    
      SELECT COUNT(*)
      INTO vCnt1
      FROM vis_d010202
      WHERE deleted = 0
      AND d010200_id = c1.id
      AND a0101_70_sid = vA0101_70_SID;
      
      IF vCnt1 = 0 THEN -- Personalfunktio nicht vorhanden
            
        UPDATE vis_d010202  -- leere Personalfunktion aktualisieren
        SET a0101_70_sid = vA0101_70_SID
          , upd_date = SYSDATE
          , upd_user = vUser_sid
        WHERE deleted = 0
        AND a0101_70_sid = -1
        AND d010200_id = c1.id;
          
        IF SQL%ROWCOUNT = 0 THEN -- keine Daten gefunden 
          InsertD010202(pD0101_3.A0101_03_SID, pD0101_3.id, c1.id);
        END IF;  
      END IF;
    END IF;
              
    EXIT;
  END LOOP;
    
  IF vHV_Exists = 0 THEN
    CreateHV();
  END IF;

END;

-- Personal bei Firmen bez_art = F
PROCEDURE Personal_F(pD0101 IN vis_d0101%ROWTYPE, pD0101_3 IN vis_d0101%ROWTYPE) AS
vHVangelegt INT := 0;
BEGIN

  -- Hauptverantwortlichen in Betrieb setzen
  FOR c1 IN (
    SELECT d010200.id 
    FROM vis_d010200 d010200
    JOIN vis_d0102 d0102 ON d0102.id = d010200.d0102_id
    AND d010200.deleted = 0
    AND d010200.d0101_id = pD0101.id
    AND D010200.HAUPTANSPRECHPARTNER = 1
  ) LOOP

    UPDATE vis_d0101
    SET d010200_id2 = c1.id
      , upd_date = SYSDATE
      , upd_user = vUser_sid
    WHERE id IN( pD0101.id );
    vHVangelegt := 1;    
    EXIT;
  END LOOP;
  
--  IF vHVangelegt = 0 THEN -- kein HV vorhanden -> Felder im BTS lschen
--    UPDATE vis_d0101
--    SET d010200_id2 = '-1'
--      , titel = NULL
--      , anrede = NULL
--      , vname = NULL
--      , nname = NULL
--      , vorsatz_nname = NULL
--      , nachsatz_nname = NULL
--   WHERE id = pD0101.id;  
--  END IF;

  -- Anprechpartner im Betreiber lschen
  UPDATE vis_d0101
  SET d010200_id2 = '-1'
    , titel = NULL
    , anrede = NULL
    , vname = NULL
    , nname = NULL
    , vorsatz_nname = NULL
    , nachsatz_nname = NULL
    , upd_date = SYSDATE    
    , upd_user = vUser_sid
 WHERE id = pD0101_3.id;  
     
  -- Personal mit bestimmten Personalfunktionen auf Betreiber verschieben
  vHVangelegt := 0;  
  IF pD0101_3.a0101_03_sid > 0 THEN
    FOR c1 IN (
      SELECT d010200.id d010200_id, d010202.id d010202_id
      , d0102.titel, d0102.anrede, d0102.vname, d0102.nname 
      , d0102.vorsatz_nname, d0102.nachsatz_nname
      , d010200.hauptansprechpartner
      , MAX(d010200.hauptansprechpartner) KEEP (DENSE_RANK FIRST ORDER BY d010200.hauptansprechpartner DESC NULLS LAST ) OVER (PARTITION BY NULL) max_hv
      FROM vis_d010200 d010200
      JOIN vis_d0102 d0102 ON d0102.id = d010200.d0102_id
      AND d010200.deleted = 0
      AND d010200.d0101_id = pD0101.id
      JOIN vis_d010202 d010202 ON d010202.d010200_id = d010200.id
      AND d010202.deleted = 0
      JOIN vis_va0088$a0101_03$a0101_70 a0088 ON a0088.a0101_70_sid = d010202.a0101_70_sid
      AND a0088.a0101_03_sid = pD0101_3.a0101_03_sid
      ORDER BY d010200.ins_date, d0102.nname, d0102.vname
    ) LOOP
    
      IF (c1.max_hv = 0 AND vHVangelegt = 0)  -- keine HV vorhanden und noch keine angelegt
      OR c1.hauptansprechpartner = 1 THEN     -- oder ist HV
        UPDATE vis_d0101
        SET d010200_id2 = c1.d010200_id
          , titel = c1.titel
          , anrede = c1.anrede
          , vname = c1.vname
          , nname = c1.nname
          , vorsatz_nname = c1.vorsatz_nname
          , nachsatz_nname = c1.nachsatz_nname
          , upd_date = SYSDATE  
          , upd_user = vUser_sid        
       WHERE id = pD0101_3.id;
       vHVangelegt := 1; 
      
      END IF;
   
      UPDATE vis_d010200
      SET d0101_id = pD0101_3.id
        , inhaber = 0
        , upd_date = SYSDATE
        , upd_user = vUser_sid
      WHERE id = c1.d010200_id;  
   
      UPDATE vis_d010202
      SET d0101_id = pD0101_3.id
        , d0103_id = '-1'  -- Abteilung zurcksetzen
        , upd_date = SYSDATE
        , upd_user = vUser_sid          
      WHERE id = c1.d010202_id;      
    
    END LOOP;
  END IF;
END;


PROCEDURE EinzelU_GbR(pD0101 IN vis_d0101%ROWTYPE) AS
  vNName vis_d0101.nname%TYPE;
  vBez vis_d0101.name1%TYPE;
  vP_Name vis_d0101.p_name%TYPE; 
  vP_Name1 vis_d0101.p_name1%TYPE; 
  vVName vis_d0101.vname%TYPE;
  --vCnt INT;
  
  --Anrede aus Inh.-Angabe herauslsen
  FUNCTION Inhaber RETURN BOOLEAN AS
  vRes BOOLEAN := TRUE;
  vName wkd_bea.nname_1%TYPE;
  BEGIN

    IF vWkd_bea.nname_1 LIKE 'Herr %'
    OR vWkd_bea.nname_1 LIKE 'Frau %' THEN
      vWkd_bea.anrede_1 := SUBSTR( vWkd_bea.NNAME_1, 1, 4 );
      vWkd_bea.nname_1 := SUBSTR( vWkd_bea.NNAME_1,    6 );
    END IF;
  
    --Titel aus Inh.-Angabe herauslsen
    IF vWKD_BEA.nname_1 like '%Dr.%' THEN    
      vWKD_BEA.titel_1 := 'Dr.';
      vWKD_BEA.nname_1 := REPLACE( vWKD_BEA.NNAME_1, 'Dr.' );
    END IF;

    --VNAME und NNAME aus Inh.-Angabe herauslsen, wenn Inh.ANgabe = NNAME,VNAME o. VNAME+NNAME
    vWKD_BEA.NNAME_1 :=
      case 
        when replace( vWKD_BEA.nname_1, ' ' )= replace( pD0101.nname||pD0101.vname, ' ') then  pD0101.nname
        when replace( vWKD_BEA.nname_1, ' ' )= replace( pD0101.vname||pD0101.nname, ' ') then  pD0101.nname
        when instr  ( vWKD_BEA.nname_1, ',' )> 1 then  trim( substr( vWKD_BEA.nname_1, 1, instr( vWKD_BEA.nname_1, ',') -1 ) )
        ELSE vWKD_BEA.NNAME_1
      end;
      
    vWKD_BEA.VNAME_1 := 
      case 
        when replace( vWKD_BEA.nname_1, ' ' )= replace( pD0101.nname||pD0101.vname, ' ') then pD0101.vname
        when replace( vWKD_BEA.nname_1, ' ' )= replace( pD0101.vname||pD0101.nname, ' ') then pD0101.vname
        when instr  ( vWKD_BEA.nname_1, ',' )> 1 then  trim( substr( vWKD_BEA.nname_1, instr(vWKD_BEA. nname_1, ',') + 1) )
      end;

    --Erster Token der Inh.-Angabe ist ein gltiger Vorname
    IF vWKD_BEA.vname_1 IS NULL
    AND INSTR( vWKD_BEA.NNAME_1, ' ' ) > 0 THEN
      vVName := nvl( trim ( dbo.get_token( replace( vWKD_BEA.NNAME_1,'-', ' '),  1, ' ' ) ), 'Klaus' );

      IF ChkVNamen( vVName ) = 1 THEN 
        vName := vWKD_BEA.nname_1;                                                                                   
        vWKD_BEA.NNAME_1 := TRIM( SUBSTR( vWKD_BEA.nname_1,    instr( vWKD_BEA.nname_1, ' ', -1, 1 )+1 ) );
        vWKD_BEA.VNAME_1 := TRIM( SUBSTR( vName, 1, instr( vName, ' ', -1, 1 )-1 ) );
      END IF;
    END IF;

    IF vWKD_BEA.VNAME_1 IS NULL
    AND INSTR( vWKD_BEA.NNAME_1, ' ') > 0 THEN     
      vWKD_BEA.nname_1 := NULL;   
      vWKD_BEA.vname_1 := NULL; 
      vRes := False;  
    END IF;
    RETURN vRes;
  END;
  
  
BEGIN
  -- 2.1 bis 2.5
  -- Titel und Namensvorsatz und Nachsatz entfernen
  IF vWKD_BEA.A0101_03_SID1 IS NULL THEN
    vNName := NamenZusatzEntfernen(pD0101.nname);
    -- kein Leerzeichen und Komma in NNAME
    IF INSTR(vNName,' ') = 0 AND INSTR(vNName,',') = 0 THEN
      vBez := UPPER(pD0101.bez);
      vP_Name := UPPER(pD0101.p_name);
      vP_Name1 := UPPER(pD0101.p_name1);
      
      vVName := REPLACE(pD0101.vname, '-', ' ') ;  

      -- Titel, NName, VName in BEZ, P_NAME, P_NAME1 und alle Vornamen sind gltig -> Einzelunternehmen
      IF NVL( INSTR( vBez, UPPER(vNName)), 1) > 0 
      AND NVL( INSTR( vBez, UPPER(pD0101.VName)), 1) > 0
      AND NVL( INSTR( vBez, UPPER(pD0101.Titel)), 1) > 0
      
      AND NVL( INSTR( vP_Name, UPPER(vNName)), 1) > 0 
      AND NVL( INSTR( vP_Name, UPPER(pD0101.VName)), 1) > 0
      AND NVL( INSTR( vP_Name, UPPER(pD0101.Titel)), 1) > 0 
      
      AND ChkVNameGbR(vVName) THEN  -- CHR(38) = &    
        -- 2.3 / 2.4 -> GbR
        vVName := BereinigungVName( vVname );
        IF ChkVnamen(vVName) = 1 THEN
          vWKD_BEA.A0101_03_SID1 := 6;  -- GbR   
          vWKD_BEA.anrede_1 := pD0101.anrede;
          vWKD_BEA.titel_1 := pD0101.titel;
          vWKD_BEA.vname_1 := pD0101.vname;
          vWKD_BEA.nname_1 := pD0101.nname;             
          --AddMsgRegel('2.3/2.4 Bezeichnung und Postbezeichnung enthalten Nachname, Vorname und Titel und Vorname enthlt mind. einen gltiger Vorname mit und/u./'||CHR(38)||' -->  GbR');
          AddMsgRegel('2.2 Bezeichnung und Postbezeichnung enthalten Nachname, Vorname und Titel und Vorname enthlt mind. einen gltiger Vorname mit und/u./'||CHR(38)||' -->  GbR');
          vWKD_BEA.result := 100;
        END IF;        
                  
      ELSIF ( NVL( INSTR( vBez, UPPER(vNName)), 1) > 0 
      AND NVL( INSTR( vBez, UPPER(pD0101.VName)), 1) > 0
      AND NVL( INSTR( vBez, UPPER(pD0101.Titel)), 1) > 0 )
      
      OR ( NVL( INSTR( vP_Name, UPPER(vNName)), 1) > 0 
      AND NVL( INSTR( vP_Name, UPPER(pD0101.VName)), 1) > 0
      AND NVL( INSTR( vP_Name, UPPER(pD0101.Titel)), 1) > 0 ) THEN

        -- 2.1 / 2.2 / 2.5.1 / 2.5.2             
        IF ChkVnamen(vVName) = 1 THEN
          vWKD_BEA.A0101_03_SID1 := 2;  -- EinzelU  
          vWKD_BEA.anrede_1 := pD0101.anrede;
          vWKD_BEA.titel_1 := pD0101.titel;
          vWKD_BEA.vname_1 := pD0101.vname;
          vWKD_BEA.nname_1 := pD0101.nname;        
          --AddMsgRegel('2.1.-2.4 Bezeichnung und Postbezeichnung = HA-Vor- und Nachname Vorname Vorname ist ein oder mehrere gltige Vornamen mit und/u./'||CHR(38)||'.');
          AddMsgRegel('2.1 Bezeichnung und Postbezeichnung = HA Vor- und Nachname, Vorname ist ein gltiger Vorname --> Einzelunternehmen');
          vWKD_BEA.result :=  
            CASE WHEN NVL( INSTR( vBez, UPPER(vNName)), 1) > 0 
                      AND NVL( INSTR( vBez, UPPER(pD0101.VName)), 1) > 0
                      AND NVL( INSTR( vBez, UPPER(pD0101.Titel)), 1) > 0                       
                      AND NVL( INSTR( vP_Name, UPPER(vNName)), 1) > 0 
                      AND NVL( INSTR( vP_Name, UPPER(pD0101.VName)), 1) > 0
                      AND NVL( INSTR( vP_Name, UPPER(pD0101.Titel)), 1) > 0 THEN 100
            ELSE 90 
            END;
        END IF;
      
      END IF;        
    END IF;
  END IF;
  IF vWKD_BEA.A0101_03_SID1 IS NULL THEN
    
    vBez := NamenZusatzEntfernen(pD0101.bez);      
    -- 2.6 BEZ ohne Leerzeichen und NAME1 ist Vorname
    IF INSTR(vBez, ' ') = 0 AND
    pD0101.vname IS NULL AND 
    pD0101.nname IS NULL AND       
    pD0101.name1 IS NULL AND
    pD0101.bez || pD0101.name1 = pD0101.p_name || pD0101.p_name1 THEN
        
      IF ChkVNameGbR(pD0101.name1) THEN  -- CHR(38) = &    
        -- 2.7 -> GbR
        vVName := BereinigungVName(pD0101.name1);
        IF ChkVnamen(vVName) = 1 THEN
          vWKD_BEA.A0101_03_SID1 := 6;  -- GbR 
          vWKD_BEA.nname_1 := pD0101.bez;
          vWKD_BEA.vname_1 := pD0101.name1;
          vWKD_BEA.result := 100;  
          AddMsgRegel('2.7 Bezeichnung enthlt Nachnamen und Bezeichnungszusatz einen oder mehrere Vornamen mit und/u,/'||CHR(38)||' getrennt, HA-Verantwortlicher nicht erfasst --> GbR');    
        END IF;
                  
      ELSIF ChkVnamen(pD0101.name1) = 1 THEN
        vWKD_BEA.A0101_03_SID1 := 2;  -- EinzelU -> 2.6    
        vWKD_BEA.nname_1 := pD0101.bez;
        vWKD_BEA.vname_1 := pD0101.name1;
        vWKD_BEA.result := 80;
        AddMsgRegel('2.6 Bezeichnung enthlt Nachnamen und Bezeichnungszusatz einen gltigen Vornamen, HA-Verantwortlicher nicht erfasst --> Einzelunternehmen');
      END IF;
        
    END IF;
  END IF;
    
  IF vWKD_BEA.a0101_03_sid1 IS NULL THEN  -- 2.8 NAME1 ohne Leerzeichen und BEZ ist Vorname
    vBez := NamenZusatzEntfernen(pD0101.name1);    
        
    IF INSTR(vBez, ' ') = 0 AND
      pD0101.vname IS NULL AND 
      pD0101.nname IS NULL AND       
      pD0101.bez IS NULL AND
      pD0101.name1 IS NOT NULL AND
      pD0101.bez || pD0101.name1 = pD0101.p_name || pD0101.p_name1 THEN
          
      IF ChkVnamen(pD0101.bez) = 1 THEN
        vWKD_BEA.A0101_03_SID1 := 2;  -- EinzelU -> 2.8
        vWKD_BEA.vname_1 := pD0101.bez;
        vWKD_BEA.nname_1 := pD0101.name1;
        vWKD_BEA.result := 90;
        AddMsgRegel('2.8 Bezeichnungszusatz enthlt Nachnamen und Bezeichnung einen mit und/u./'||CHR(38)||' getrennt, HA-Verantwortlicher nicht erfasst --> Einzelunternehmen');
      END IF;
    END IF;
          
  END IF;   

  --Fall: Berlin
  --P_NAME = <vname> <nname>
  IF vWKD_BEA.A0101_03_SID1 IS NULL AND
  INSTR( pD0101.p_name, ',') = 0 THEN
    vWkd_bea.nname_1 := TRIM( SUBSTR( pD0101.P_NAME, INSTR( pD0101.P_NAME, ' ', -1,  1 )+1 ) );
    vWkd_bea.vname_1 := TRIM( SUBSTR( pD0101.P_NAME, 1, INSTR( pD0101.P_NAME, ' ', -1,  1 )-1 ) );    
  END IF;

  --P_NAME = <nname>, <vname>
  IF vWKD_BEA.A0101_03_SID1 IS NULL AND
  INSTR( pD0101.p_name, ',') > 0 THEN
    vWkd_bea.nname_1 := TRIM( SUBSTR( pD0101.P_NAME, 1, INSTR( pD0101.P_NAME, ',' )-1 ) );
    vWkd_bea.vname_1 := TRIM( SUBSTR( pD0101.P_NAME, INSTR( pD0101.P_NAME, ',' )+1 ) );    
  END IF;
 
  IF vWKD_BEA.A0101_03_SID1 IS NULL AND
  INSTR(vWKD_BEA.nname_1, ' ') = 0 THEN
    IF ChkVnamen( REPLACE(vWKD_BEA.vname_1, '-', ' ') ) = 1 THEN
      vWKD_BEA.A0101_03_SID1 := 2;  -- EinzelU -> 2.12 / 2.13
      vWkd_bea.result := 50      
          + case when pD0101.P_NAME = pD0101.BEZ then 25 else 0 end
          + case when replace( replace( pD0101.P_NAME      , ','), ' ')
                    = replace( replace( pD0101.nname||pD0101.vname, ','), ' ') then 25
                 when replace( replace( pD0101.P_NAME      , ','), ' ')
                    = replace( replace( pD0101.vname||pD0101.nname, ','), ' ') then 25
                 when pD0101.nname||pD0101.vname is null then 15 
                 else 0 end;    
      AddMsgRegel( 
            CASE 
            WHEN INSTR( pD0101.P_NAME, ',' ) = 0 then '2.10 Postbezeichnung enthlt einen gltigen Vor- und Nachname, ungleich HA --> Einzelunternehmen'
            WHEN INSTR( pD0101.P_NAME, ',' ) > 0 then '2.11 Postbezeichnung enthlt einen gltigen Nach- und Vonamen, ungleich HA --> Einzelunternehmen'            
            END);            
    END IF;        
  END IF;  
 
  IF vWKD_BEA.A0101_03_SID1 IS NULL AND
  INSTR(vWKD_BEA.nname_1, ' ') = 0 AND
  vWkd_Bea.vname_1 IS NOT NULL AND
  ChkVNameGbR( vWkd_Bea.vname_1 ) THEN
  
    vVName := BereinigungVName( vWkd_Bea.vname_1 );
    IF ChkVnamen(vVName, 1) = 1 THEN
      vWKD_BEA.A0101_03_SID1 := 6; --GbR
      vWkd_bea.result := 50
        + case when pD0101.P_NAME = pD0101.BEZ then 25 else 0 end
        + case when replace( replace( pD0101.P_NAME      , ','), ' ')
                  = replace( replace( pD0101.nname||pD0101.vname, ','), ' ') then 25
               when replace( replace( pD0101.P_NAME      , ','), ' ')
                  = replace( replace( pD0101.vname||pD0101.nname, ','), ' ') then 25
               when pD0101.nname||pD0101.vname is null then 15 
               else 0 end;  
      AddMsgRegel(
        case 
        when instr( pD0101.P_NAME, ',' ) = 0 then '2.12.Postbezeichnung enthlt mehrere gltigen Vornamen mit und/u./'||CHR(38)||' getrennt und einen Nachname, ungleich HA --> GbR'
        when instr( pD0101.P_NAME, ',' ) > 0 then '2.13.Postbezeichnung enthlt eine Nachmane und mehrere gltige Vornamen mit und/u./'||CHR(38)||' getrennt, ungleich HA --> GbR'
        end);  
    
    END IF;
  
  END IF;

  IF vWKD_BEA.A0101_03_SID1 IS NULL THEN
    vWKD_Bea.nname_1 := NULL;
    vWKD_BEA.vname_1 := NULL;
  END IF;

  IF vWKD_BEA.a0101_03_sid1 IS NULL THEN  -- 2.10 Nachname in BEZ und P_NAME enthalten und gltiger Vorname
    vBez := NamenZusatzEntfernen(pD0101.nname);   
    IF INSTR(vBez, ' ') = 0 AND INSTR(vBez, ',') = 0 AND
      pD0101.vname IS NULL AND 
      pD0101.nname IS NULL AND       
      pD0101.bez IS NULL AND
      pD0101.p_name IS NOT NULL AND
      INSTR(pD0101.bez, pD0101.nname) > 0 AND
      INSTR(pD0101.p_name, pD0101.nname) > 0 THEN        

      IF ChkVnamen(pD0101.vname) = 1 THEN
        vWKD_BEA.A0101_03_SID1 := 2;  -- EinzelU -> 2.8
        vWKD_BEA.titel_1 := pD0101.titel;
        vWKD_BEA.anrede_1 := pD0101.anrede;
        vWKD_BEA.vname_1 := pD0101.vname;
        vWKD_BEA.nname_1 := pD0101.nname;          
        vWKD_BEA.result := 70;
        AddMsgRegel('2.14.Postbezeichnung enthlt eine Nachmane des HA und der HA-Vorname ist ein gltiger Vorname --> Einzelunternehmen');
      END IF;
        
    END IF;
  END IF;

  IF vWKD_BEA.a0101_03_sid1 IS NULL THEN  -- 2.11 Nachname in BEZ und P_NAME enthalten und Anrede = Herr o. Frau
    vBez := NamenZusatzEntfernen(pD0101.nname);
    IF INSTR(vBez, ' ') = 0 AND
    INSTR( pD0101.nname, ',') = 0 AND
    pD0101.anrede IN ('Herr', 'Frau') AND
    INSTR(pD0101.bez, pD0101.nname) > 0 AND
    INSTR(pD0101.p_name, pD0101.nname) > 0 THEN
    
      vWKD_BEA.A0101_03_SID1 := 2;  -- EinzelU -> 2.11
      vWKD_BEA.anrede_1 := pD0101.anrede;
      vWKD_BEA.titel_1 := pD0101.titel;
      vWKD_BEA.vname_1 := pD0101.vname;
      vWKD_BEA.nname_1 := pD0101.nname;
      vWKD_BEA.result := 90
            - case when pD0101.nname = ltrim( rtrim( pD0101.P_NAME, ', '), ', ' ) then 0 else 10 end 
            - case when pD0101.nname = ltrim( rtrim( pD0101.BEZ   , ', '), ', ' ) then 0 else 10 end 
            - case when pD0101.BEZ_ART = 'N' then 0 else 10 end;
      AddMsgRegel('2.15.Postbezeichnung enthlt einen Nachnamen des HA und Anrede des HA ist Herr o. Frau --> Einzelunternehmen');
    END IF;
       
  END IF; 

  --------------------------------------------------------------------------------------------------------------------  
  -- Inh.-Angabe in BEZ-bzw.Namens-Feldern
  --------------------------------------------------------------------------------------------------------------------  
  IF vWKD_BEA.A0101_03_SID1 IS NULL 
  AND pD0101.bez = pD0101.P_NAME
  AND INSTR ( pD0101.P_NAME, 'Inh.' ) > 0
  AND INSTR ( pD0101.P_NAME, NVL( pD0101.nname, 'I' ) ) > 0
  AND INSTR ( pD0101.P_NAME, NVL( pD0101.vname, 'I' ) ) > 0 THEN

    vWKD_Bea.A0101_03_SID1 := 2; -- EinzelU
    vWKD_Bea.result := 80;
    vWKD_BEA.nname_1 :=  TRIM( LTRIM( SUBSTR( pD0101.P_NAME, INSTR ( pD0101.P_NAME, 'Inh.' )+4), ':-') );
    IF Inhaber THEN
      AddMsgRegel('3.1 Krzel "Inh." mit Name des Inhaber steht in Post-Bezeichnung und weicht nicht von HA-Vor- und Nachname ab --> Einzelunternehmen');
    END IF;
  END IF;  

  IF vWKD_BEA.A0101_03_SID1 IS NULL 
  AND pD0101.bez = pD0101.P_NAME
  AND INSTR ( pD0101.P_NAME1, 'Inh.' ) > 0
  AND INSTR ( pD0101.P_NAME1, NVL( pD0101.nname, 'I' ) ) > 0
  AND INSTR ( pD0101.P_NAME1, NVL( pD0101.vname, 'I' ) ) > 0 THEN

    vWKD_Bea.A0101_03_SID1 := 2; -- EinzelU
    vWKD_Bea.result := 80;
    vWKD_BEA.nname_1 :=  TRIM( LTRIM( SUBSTR( pD0101.P_NAME1, INSTR ( pD0101.P_NAME1, 'Inh.' )+4), ':-') );
    IF Inhaber THEN
      AddMsgRegel('3.2 Krzel "Inh." mit Name des Inhaber steht in Post-Bezeichnung2 und weicht nicht von HA-Vor- und Nachname ab --> Einzelunternehmen');
    END IF;
  END IF; 

  IF vWKD_BEA.A0101_03_SID1 IS NULL 
  AND pD0101.bez = pD0101.P_NAME
  AND INSTR ( pD0101.bez, 'Inh.' ) > 0
  AND INSTR ( pD0101.bez, NVL( pD0101.nname, 'I' ) ) > 0
  AND INSTR ( pD0101.bez, NVL( pD0101.vname, 'I' ) ) > 0 THEN
    vWKD_Bea.A0101_03_SID1 := 2; -- EinzelU
    vWKD_Bea.result := 80;
    vWKD_Bea.nname_1 := TRIM( LTRIM( SUBSTR( pD0101.bez, INSTR ( pD0101.bez, 'Inh.' )+4), ':-' ) );
    IF Inhaber THEN
      AddMsgRegel('3.3 Krzel "Inh." mit Name des Inhaber steht in Bezeichnung und weicht nicht von HA-Vor- und Nachname ab --> Einzelunternehmen');
    END IF;
  END IF;

  IF vWKD_BEA.A0101_03_SID1 IS NULL 
  AND pD0101.bez||pD0101.name1 = pD0101.P_NAME||pD0101.P_name1
  AND INSTR ( pD0101.name1, 'Inh.' ) > 0
  AND INSTR ( pD0101.name1, NVL( pD0101.nname, 'I' ) ) > 0
  AND INSTR ( pD0101.name1, NVL( pD0101.vname, 'I' ) ) > 0 THEN
    vWKD_Bea.A0101_03_SID1 := 2; -- EinzelU
    vWKD_Bea.result := 80;
    vWKD_Bea.nname_1 := TRIM( LTRIM( SUBSTR( pD0101.name1, INSTR ( pD0101.name1, 'Inh.' )+4), ':-' ) );
    IF Inhaber THEN
      AddMsgRegel('3.4 Krzel "Inh." mit Name des Inhaber steht in Bezeichnungs_Zusatz und weicht nicht von HA-Vor- und Nachname ab --> Einzelunternehmen');
    END IF;
  END IF;

  --------------------------------------------------------------------------------------------------------------------------------
  IF vWKD_BEA.A0101_03_SID1 IS NULL AND
  INSTR( pD0101.nname, ' ') = 0 AND
  INSTR( pD0101.nname, ',') = 0 AND
  ChkVNameGbr(pD0101.vname) THEN
  
    vVName := BereinigungVName(pD0101.vname);
    IF ChkVnamen(vVName) = 1 THEN
      vWKD_Bea.A0101_03_SID1 := 6; -- GbR
      vWKD_BEA.nname_1 := pD0101.nname;
      vWKD_BEA.vname_1 := pD0101.vname;
      vWKD_BEA.result := 30 + CASE WHEN pD0101.bez = pD0101.p_name THEN 10 ELSE 0 END;
       
      IF pD0101.bez = pD0101.p_name THEN
        AddMsgRegel('4.3 - Post-Bezeichnung =  Bezeichnung UND HA-Vorname enthlt mehrere gltige Vornamen mit und/u./'||CHR(38)||' getrennt, HA --> GbR');
      ELSE 
        AddMsgRegel('4.4 - Post-Bezeichnung <>  Bezeichnung UND HA-Vorname enthlt mehrere gltige Vornamen mit und/u./'||CHR(38)||' getrennt, HA --> GbR');
      END IF;
    END IF;
  END IF;  

  IF vWKD_BEA.A0101_03_SID1 IS NULL AND
  INSTR( pD0101.nname, ' ') = 0 AND
  INSTR( pD0101.nname, ',') = 0 AND
  ChkVNamen( REPLACE( pD0101.vname, '-', ' ') ) = 1 THEN
    vWKD_BEA.nname_1 := pD0101.nname;
    vWKD_BEA.vname_1 := pD0101.vname;
    vWKD_Bea.A0101_03_SID1 := 2; -- EinzelU
    vWKD_Bea.result := 30 + CASE when pD0101.bez = pD0101.P_NAME then 10 else 0 end;
    IF pD0101.bez = pD0101.p_name THEN
      AddMsgRegel('4.1 - Post-Bezeichnung =  Bezeichnung UND HA-Vorname ist gltiger Vorname, HA --> Einzelunternehmen');
    ELSE
      AddMsgRegel('4.2 - Post-Bezeichnung <>  Bezeichnung  UND HA-Vorname ist gltiger Vorname, HA --> Einzelunternehmer');
    END IF;
  END IF;
  
  IF vWKD_BEA.A0101_03_SID1 IS NULL AND
  INSTR( pD0101.nname, ' ') = 0 AND
  INSTR( pD0101.nname, ',') = 0 AND
  pD0101.anrede IN ( 'Herr', 'Frau' ) THEN

    vWKD_BEA.nname_1 := pD0101.nname;
    vWKD_BEA.vname_1 := pD0101.vname;
    vWKD_BEA.result := 20 + CASE WHEN pD0101.bez = pD0101.p_name THEN 10 ELSE 0 END;
    vWKD_BEA.a0101_03_sid1 := 2; -- EinzelU
    AddMsgRegel('4.5 - Hauptansprechpartner mit Anrede = Herr/Frau, HA --> Einzelunternehmer');
  END IF;

  IF vWKD_BEA.A0101_03_SID1 IS NULL AND
  INSTR( pD0101.nname, ' ') = 0 AND
  INSTR( pD0101.nname, ',') = 0 AND
  pD0101.anrede IN ( 'Herr und Frau', 'Herr u. Frau', 'Herr '||CHR(38)||' Frau', 'Familie', 'Eheleute' ) THEN

    vWKD_BEA.nname_1 := pD0101.nname;
    vWKD_BEA.vname_1 := pD0101.vname;
    vWKD_BEA.result := 20 + CASE WHEN pD0101.bez = pD0101.p_name THEN 10 ELSE 0 END;
    vWKD_BEA.a0101_03_sid1 := 6; -- GbR
    AddMsgRegel('4.6 - Hauptansprechpartner mit Anrede = Herr u. Frau/Familie/Eheleute, HA --> GbR');
  END IF;

  IF vWKD_BEA.a0101_03_sid1 IS NULL THEN
    vWKD_BEA.nname_1 := NULL;
    vWKD_BEA.vname_1 := NULL;
  END IF;

  IF vWKD_BEA.a0101_03_sid1 IS NULL AND 
  pD0101.a0101_03_sid > 0 AND
  pD0101.nname IS NOT NULL THEN
    
    AddMsgRegel('5.00 - Erfasste Rechtsform Einzelunternehmen beibehalten');
    vWKD_BEA.result := 80;
    vWKD_BEA.a0101_03_SID1 := pD0101.a0101_03_sid;
    vWKD_BEA.p_name_1 := NVL(pD0101.p_name, pD0101.bez);
    vWKD_BEA.p_name1_1 := pD0101.p_name1;  
    vWKD_BEA.bez1 := NVL(pD0101.p_name, pD0101.bez);
    vWKD_BEA.name1_1 := CASE WHEN nvl( pD0101.P_NAME, pD0101.BEZ ) <> pD0101.bez THEN trim( pD0101.bez||' '||pD0101.name1 ) end;     
    vWKD_BEA.anrede_1 := pD0101.anrede;
    vWKD_BEA.titel_1 := pD0101.titel;
    vWKD_BEA.nname_1 := pD0101.nname;
    vWKD_BEA.vname_1 := pD0101.vname;
  END IF; 

  --P_NAME und BEZ fr Einzelunternehmen setzen
  IF vWKD_BEA.a0101_03_sid1 = 2 AND
  pD0101.id = pD0101.d0101_id3 THEN
  
    vWKD_BEA.P_NAME_1 := SUBSTR( trim(  trim( vWKD_BEA.titel_1||' '||vWKD_BEA.vname_1)||' '||vWKD_BEA.nname_1 ), 1, 128);
    vWKD_BEA.p_name1_1 := SUBSTR( IsGleich(vWKD_BEA.P_NAME_1, pD0101.P_NAME, pD0101.P_NAME1), 1, 256);
    vWKD_BEA.bez1 := SUBSTR( rtrim( rtrim( vWKD_BEA.nname_1||', '||vWKD_BEA.vname_1, ', ')||', '||vWKD_BEA.titel_1, ', ' ), 1, 128);
    vWKD_BEA.name1_1 := SUBSTR(IsGleich( vWKD_BEA.bez1, pD0101.bez, pD0101.NAME1), 1, 256);
  END IF; 


  IF vWKD_BEA.a0101_03_SID1 = 6 AND
  vRegelMsg NOT LIKE '1%' AND
  pD0101.id = pD0101.d0101_id3 THEN
    vWKD_BEA.p_name_1 := SUBSTR(trim( trim( vWKD_BEA.titel_1||' '||vWKD_BEA.vname_1)||' '||vWKD_BEA.nname_1 )||' GbR', 1, 128);
    vWKD_BEA.p_name1_1 := SUBSTR(IsGleich(vWKD_BEA.p_name_1, pD0101.P_NAME, pD0101.P_NAME1), 1, 256);
    vWKD_BEA.bez1 := SUBSTR(trim( trim( vWKD_BEA.titel_1||' '||vWKD_BEA.vname_1)||' '||vWKD_BEA.nname_1 )||' GbR', 1, 128) ;
    vWKD_BEA.name1_1 := SUBSTR(IsGleich( vWKD_BEA.bez1, pD0101.BEZ, pD0101.NAME1), 1, 256);

  END IF;

  --BEZ = P_NAME fr Rechtsform <> EinzelU, GbR setzen
  IF vWKD_BEA.A0101_03_sid1 NOT IN (-1, 2, 6) AND
  pD0101.id = pD0101.d0101_id3 THEN
    vWKD_BEA.bez1 := vWKD_BEA.p_name_1;
    vWKD_BEA.name1_1 := IsGleich(vWKD_BEA.bez1, pD0101.bez, pD0101.name1);
  END IF;

  IF vWKD_BEA.a0101_03_sid1 > -1 AND 
  pD0101.id <> pD0101.d0101_id3 THEN 
    
    -- 21.10.2014
    -- wenn Betreiber daten_herkunft = BEA dann Rechtsform aus d0101 sonst wkd_bea prfen
    DECLARE 
    vDH vis_d0101.daten_herkunft%TYPE;
    vA0101_03_sid vis_d0101.a0101_03_sid%TYPE;
    vA0101_03_kurzb vis_a0101.kurzb%TYPE;
    BEGIN
      SELECT d0101.daten_herkunft, d0101.a0101_03_sid, a0101.kurzb
      INTO vDH, vA0101_03_sid, vA0101_03_kurzb
      FROM vis_d0101 d0101 
      JOIN vis_a0101 a0101 ON a0101.sid = d0101.a0101_03_sid 
      AND d0101.id = pD0101.d0101_id3;
      
      IF vDH = 'BEA' THEN 
        IF vA0101_03_SID > 0 AND vA0101_03_SID <> vWKD_BEA.a0101_03_sid1 THEN
          --02.12.2014 SL
          IF  vRegelMsg LIKE '1%' THEN
            vWKD_BEA.result := -1;
            AddMsgRegel('Die Rechtsform des Betreibers ist abweichend ('|| vA0101_03_kurzb||') !!!');
          ELSE
            vWKD_BEA.result := 100;
            vWKD_BEA.a0101_03_sid1 := vA0101_03_SID;
            AddMsgRegel('Der Betreiber ist bereits bereinigt, und die Rechtsform (' || vA0101_03_kurzb || ') wird beibehalten.');
          END IF;
        END IF;
      ELSE
      
        --PRIO = 10, wenn Rechtsform des Betreibers abweichend
        FOR c1 IN (
          SELECT a0101_03.kurzb --, d0101.daten_herkunft
          FROM wkd_bea dx
          JOIN vis_a0101 a0101_03 ON a0101_03.sid = dx.a0101_03_sid1
          --JOIN vis_d0101 d0101 ON d0101.id = dx.d0101_id 
          WHERE dx.d0101_id = pD0101.d0101_id3 
          AND dx.a0101_03_sid1 <> vWKD_BEA.a0101_03_sid1
        ) LOOP
          vWKD_BEA.result := -1;
          AddMsgRegel('Die Rechtsform des Betreibers ist abweichend ('|| c1.kurzb||') !!!');
        END LOOP;
      END IF;
    END;
	-- 10.12.2014  Betriebssttte ohne Vorschlag Rechtsform mit abweichenden Betreiber  
	ELSIF NVL(vWKD_BEA.a0101_03_sid1, -1) = -1 AND 
  pD0101.id <> pD0101.d0101_id3 THEN 
		
		DECLARE 
    vDH vis_d0101.daten_herkunft%TYPE;
    vA0101_03_sid vis_d0101.a0101_03_sid%TYPE;
    vA0101_03_kurzb vis_a0101.kurzb%TYPE;
    BEGIN
      SELECT d0101.daten_herkunft, d0101.a0101_03_sid, a0101.kurzb
      INTO vDH, vA0101_03_sid, vA0101_03_kurzb
      FROM vis_d0101 d0101 
      JOIN vis_a0101 a0101 ON a0101.sid = d0101.a0101_03_sid 
      AND d0101.id = pD0101.d0101_id3;
      
      IF vDH = 'BEA' THEN 
				vWKD_BEA.result := 100;
				vWKD_BEA.a0101_03_sid1 := vA0101_03_SID;
				AddMsgRegel('Der Betreiber ist bereits bereinigt, und die Rechtsform (' || vA0101_03_kurzb || ') wird beibehalten.');
        END IF;
		END;
  END IF;  
      
  IF vWKD_BEA.a0101_03_sid0 > -1 AND 
  vWKD_BEA.a0101_03_sid1 <> vWKD_BEA.A0101_03_sid0 AND 
  pD0101.id = pD0101.d0101_id3 THEN 
    
    --PRIO = 10, wenn Rechtsform des Betreibers abweichend
    vWKD_BEA.result := 10;
    AddMsgRegel('Eine abweichende Rechtsform wurde ermittelt!!!');
  END IF; 

  --BEZ und P_NAME und Rechtsform aus Betreiberdatensatz setzen
  IF pD0101.id <> pD0101.d0101_ID3 AND 
  vWKD_BEA.A0101_03_sid1 > 0 THEN
       
    DECLARE 
      vLP_name wkd_bea.p_name_1%TYPE;
      vLBez wkd_bea.bez1%TYPE;
      vLA0101_03_sid wkd_bea.a0101_03_sid1%TYPE; 
      vResult wkd_bea.result%TYPE;
      vDH vis_d0101.daten_herkunft%TYPE;
    BEGIN    
      -- 21.10.2014 Umstellung, wenn Betreiber = BEA dann kann Betrieb analysiert werden
      SELECT d0101.daten_herkunft
      , CASE WHEN d0101.daten_herkunft = 'BEA' OR bea.d0101_id IS NULL THEN d0101.p_name ELSE bea.p_name_1 END
      , CASE WHEN d0101.daten_herkunft = 'BEA' OR bea.d0101_id IS NULL THEN d0101.bez ELSE bea.bez1 END
      , CASE WHEN d0101.daten_herkunft = 'BEA' OR bea.d0101_id IS NULL THEN d0101.a0101_03_sid ELSE bea.a0101_03_sid1 END
      , bea.result 
      INTO vDH, vLP_name, vLBez, vLA0101_03_sid, vResult
      FROM vis_d0101 d0101
      LEFT JOIN wkd_bea bea ON bea.d0101_id = d0101.id 
      WHERE d0101.ID = pD0101.d0101_ID3;

      --SELECT t1.p_name_1, t1.bez1, t1.a0101_03_sid1, t1.result 
      --INTO vLP_name, vLBez, vLA0101_03_sid, vResult
      --FROM wkd_bea t1 
      --WHERE t1.d0101_ID = pD0101.d0101_ID3;

      IF vLA0101_03_sid > 0 THEN
        vWKD_BEA.p_name_1 := vLP_name;
        vWKD_BEA.bez1 := vLBez;
        vWKD_BEA.a0101_03_sid1 := vLA0101_03_sid;
        vWKD_BEA.bez1_field := 'Betreiber';
        --vWKD_BEA.result := vResult;
      ELSIF vLA0101_03_sid = -1 AND vDH = 'BEA' THEN
        --vWKD_BEA.result := -1;
        AddMsgRegel('Der Betreiber hat keine Rechtsform.');
      END IF;
      -- 21.10.2014 nicht mehr notwendig
      --EXCEPTION WHEN no_data_found then
      --  AddMsgRegel('Der Betreiber ist noch nicht analysiert.');
      --  vWKD_BEA.result := -1;
    END;

    vWKD_BEA.name1_1 := IsGleich(vWKD_BEA.bez1, pD0101.BEZ, pD0101.NAME1);
    vWKD_BEA.p_name1_1 := IsGleich(vWKD_BEA.p_name_1, pD0101.P_NAME, pD0101.P_NAME1);

  END IF;

  IF vWKD_BEA.bez1 = vWKD_BEA.name1_1 THEN
    vWKD_BEA.name1_1 := NULL;    
  END IF;

  IF vWKD_BEA.p_name_1 = vWKD_BEA.p_name1_1 THEN
    vWKD_BEA.p_name1_1 := NULL;
  END IF;


  --update t_BEA T SET
  --   nname_1 = nname
  -- , vname_1 = vname   
  --where nname_1 IS NULL
  --  and nname IS NOT NULL
  IF vWKD_BEA.nname_1 IS NULL AND pD0101.nname IS NOT NULL THEN
    vWKD_BEA.nname_1 := pD0101.nname;
    vWKD_BEA.vname_1 := pD0101.vname;
  END IF;

  IF pD0101.nname IS NOT NULL THEN
    vWKD_BEA.nname_1 := pD0101.nname;
    vWKD_BEA.vname_1 := pD0101.vname;        
  END IF;

  --update t_BEA T SET
  --  anrede_1 = anrede
  --where anrede_1 is NULL
  --  and nname_1||'_' = nname||'_'
  --  and vname_1||'_' = vname||'_'

  IF vWKD_BEA.anrede_1 IS NULL AND
  vWKD_BEA.nname_1||'_' = pD0101.nname||'_' AND
  vWKD_BEA.vname_1||'_' = pD0101.vname||'_' THEN
  
    vWKD_BEA.anrede_1 := pD0101.anrede;
  END IF;
  
  
  --update t_BEA T SET
  --  titel_1 = titel
  --where anrede_1 is NULL
  --  and nname_1||'_' = nname||'_'
  --  and vname_1||'_' = vname||'_'
  IF vWKD_BEA.titel_1 IS NULL AND
  vWKD_BEA.nname_1||'_' = pD0101.nname||'_' AND
  vWKD_BEA.vname_1||'_' = pD0101.vname||'_' THEN
  
    vWKD_BEA.titel_1 := pD0101.titel;
  END IF;

  --update t_BEA T SET
  --  anrede_1 = ( select case when min( anrede) = max( anrede) then min( anrede) end 
  --               from vis_A0081 a0081 where a0081.vname = trim ( dbo.get_token( replace( vname,'-', ' '),  1, ' ' ) ) 
  --             )
  --where anrede_1 is NULL
  --  and vname_1 is not null

  IF vWKD_BEA.anrede_1 IS  NULL AND
  vWKD_BEA.vname_1 IS NOT NULL THEN
    
    vVName := TRIM( dbo.get_token( REPLACE(vWKD_BEA.vname_1, '-', ' '), 1, ' '));
    IF vVName IS NOT NULL THEN
      BEGIN  
        SELECT MAX(a0081.anrede) INTO vWKD_BEA.anrede_1
        FROM vis_a0081 a0081
        WHERE a0081.vname = vVName
        HAVING MIN(anrede) = MAX(anrede);        
        
        EXCEPTION WHEN NO_DATA_FOUND THEN NULL;
      END;
    END IF;
      
  END IF;

--update t_BEA T SET
--   prio = 0
--where regel1 is null;   
  CASE
  WHEN vWKD_BEA.result = -1 THEN
  
    vWKD_BEA.bez1 := NULL;
    vWKD_BEA.name1_1 := NULL;
    vWKD_BEA.bez_art1 := NULL;
    vWKD_BEA.p_name_1 := NULL;
    vWKD_BEA.p_name1_1 := NULL;
    vWKD_BEA.vname_1 := NULL;
    vWKD_BEA.nname_1 := NULL;
    vWKD_BEA.titel_1 := NULL;
    vWKD_BEA.anrede_1 := NULL;
    vWKD_bea.a0101_03_sid1 := NULL;
  
  WHEN vWKD_BEA.bez0||CHR(6) = vWKD_BEA.bez1||CHR(6) AND
  vWKD_BEA.name1_0||CHR(6) = vWKD_BEA.name1_1||CHR(6) AND
  vWKD_BEA.p_name_0||CHR(6) = vWKD_BEA.p_name_1||CHR(6) AND
  vWKD_BEA.p_name1_0||CHR(6) = vWKD_BEA.p_name1_1||CHR(6) AND
  (vWKD_BEA.a0101_03_sid0 = vWKD_BEA.a0101_03_sid1 OR vWKD_BEA.a0101_03_sid0 = -1) THEN
  
    vWKD_BEA.result := 101;
  ELSE NULL;
  END CASE;

END;

PROCEDURE ChkRechtsform(pD0101 IN vis_d0101%ROWTYPE) AS
  vName VARCHAR2(2000 CHAR);
  vA0101_03_SID1 vis_a0101.sid%TYPE;
  vA0101_03_kurzb1 vis_a0101.kurzb%TYPE;
  vA0101_03_kurzb0 vis_a0101.kurzb%TYPE;
  vVergleich INT;
   
  -- Inhalt fr neue Bezeichnung merken
  PROCEDURE SetBez_Neu(pU_Kurzb IN VARCHAR2, pKurzb IN VARCHAR2) AS
    FUNCTION Vergleich(p2 IN VARCHAR2, p3 IN VARCHAR2, p4 IN INT) RETURN BOOLEAN AS
      v1 VARCHAR2(1000) := UPPER(p2);
      vRes BOOLEAN := FALSE;
    BEGIN
      vVergleich := 0;
      IF  ' ' || v1 || ' ' LIKE '%'||pU_Kurzb||'%' THEN
        vRes := TRUE;
        IF p4 = 1 THEN
          IF v1 = pU_Kurzb THEN  -- wenn nur Rechtform im feld dann an bez anhngen         
            --vWKD_BEA.bez1 := vWKD_BEA.bez1 || ' ' || p2;
            vVergleich := 1;
          ELSE
            NULL; --vWKD_BEA.Bez1 := p2;
          END IF;          
        END IF;
        vWKD_BEA.Bez1_Field := p3;     

        vWKD_BEA.result := 90;
        AddMsgRegel('1. Rechtsformkrzel ist enthalten in ' || p3 || ' --> ' || pKurzb );        

      END IF;
            
      RETURN vRes;
    END Vergleich;

  BEGIN

    CASE 
    WHEN Vergleich(pD0101.bez, 'Bezeichnung',1) THEN
      --IF vVergleich = 1 THEN
        vWKD_BEA.p_name_1 := pD0101.bez;
      --END IF;    
    WHEN Vergleich(pD0101.name1, 'Standortbez.', 1) THEN
      IF vVergleich = 1 THEN
        vWKD_BEA.p_name_1 := pD0101.p_name ||' '||pD0101.p_name1; 
      ELSE
        vWKD_BEA.p_name_1 := pD0101.name1;        
      END IF;

    WHEN Vergleich(pD0101.p_name, 'Post-Bezeichnung', 1) THEN
      --IF vVergleich = 1 THEN
        vWKD_BEA.p_name_1 := pD0101.p_name;
        vWKD_BEA.p_name1_1 := pD0101.p_name1;
      --END IF;

    WHEN Vergleich(pD0101.p_name1, 'Post zus. Bez.', 1) THEN
      IF vVergleich = 1 THEN
        vWKD_BEA.p_name1_1 := NULL;
        vWKD_BEA.p_name_1 := pD0101.p_name ||' '|| pD0101.p_name1;
      ELSE
        vWKD_BEA.p_name_1 := pD0101.p_name1;
        vWKD_BEA.p_name1_1 := pD0101.p_name;
      END IF;

    --WHEN Vergleich(pD0101.p_name2, 'Post zus. Bez. 2', 1) THEN
    --  vWKD_BEA.p_name_1 := pD0101.p_name2;
--      IF vVergleich = 1 THEN
--      vWKD_BEA.p_name2_1 := NULL;
--      END IF;

    WHEN Vergleich(pD0101.vname, 'Vorname', 1) THEN      
      --IF vVergleich = 1 THEN
      vWKD_BEA.p_name_1 := pD0101.vname;
      --END IF;

    WHEN Vergleich(pD0101.nname, 'Nachname', 1) THEN
      --IF vVergleich = 1 THEN
        vWKD_BEA.p_name_1 := pD0101.nname;
      --END IF;
          
    ELSE
      NULL;
    END CASE; 

  END;
  
BEGIN

  vA0101_03_kurzb1 := NULL;
  vA0101_03_kurzb0 := NULL;
      
  -- Rechtsform ber Katalog ermitteln
  vName :=  UPPER( 
          ' '|| pD0101.bez ||' '|| pD0101.name1 ||' '|| 
          pD0101.p_name ||' '|| pD0101.p_name1 ||' '|| /*pD0101.p_name2 ||' '||*/ 
          pD0101.vname ||' '|| pD0101.nname || ' '); -- ||' '|| v1 ||' '|| v2 ||' ');

  vName := REPLACE( vName, '-', ' ');
  vName := REPLACE( vName, '(', ' ');
  vName := REPLACE( vName, ')', ' ');
 
  vA0101_03_SID1 := NULL;
  
  FOR c1 IN (
    SELECT ax.sid, UPPER(ax.kurzb) U_kurzb, ax.kurzb 
    FROM (
      SELECT CASE WHEN ax.deleted = -3 THEN ax.a0101_sid0 ELSE ax.sid END sid, ax.bez, ax.kurzb
      FROM vis_a0101 ax
      WHERE ax.skz = 3
        AND ax.deleted IN( 0, -1, -3)
        AND ax.kurzb IS NOT NULL
        AND ax.mandant = -1
        AND vName LIKE '% ' || UPPER(ax.kurzb) || ' %'
      ORDER BY LENGTH(ax.kurzb) DESC NULLS LAST -- lngste Rechtsform zuerst 
    ) ax
    WHERE rownum = 1
  ) LOOP      
  
    vWKD_BEA.a0101_03_sid1 := c1.sid;
    SetBez_Neu(c1.u_kurzb, c1.kurzb );
    
    vWKD_BEA.bez1 := vWKD_BEA.p_name_1;
    vWKD_BEA.name1_1 := IsGleich(vWKD_BEA.bez1, vWKD_BEA.bez0, vWKD_BEA.name1_0);
    
    vWKD_BEA.p_name1_1 := IsGleich(vWKD_BEA.p_name_1, vWKD_BEA.p_name_0, vWKD_BEA.p_name1_0);  
    EXIT;
  END LOOP;
  
  IF vWKD_BEA.a0101_03_sid1 IS NULL AND 
  pD0101.a0101_03_sid NOT IN (-1, 2) THEN
    
    AddMsgRegel('1.10 - Erfasste Rechtsform beibehalten');
    vWKD_BEA.result := 80;
    vWKD_BEA.a0101_03_SID1 := pD0101.a0101_03_sid;
    vWKD_BEA.p_name_1 := NVL(pD0101.p_name, pD0101.bez);
    vWKD_BEA.p_name1_1 := pD0101.p_name1;  
    vWKD_BEA.bez1 := NVL(pD0101.p_name, pD0101.bez);
    vWKD_BEA.name1_1 := CASE WHEN NVL( pD0101.P_NAME, pD0101.BEZ ) <> pD0101.bez 
                        THEN TRIM( pD0101.bez||' '||pD0101.name1 ) 
                        ELSE pD0101.name1   -- 02.10.2014 bugfix                                        
                        END;
    vWKD_BEA.anrede_1 := pD0101.anrede;
    vWKD_BEA.titel_1 := pD0101.titel;
    vWKD_BEA.nname_1 := pD0101.nname;
    vWKD_BEA.vname_1 := pD0101.vname;
  END IF;
    
     
  -- keine Rechtsform vorhanden 
  --IF vWKD_BEA.a0101_03_sid1 IS NULL /*AND pD0101.A0101_03_SID = -1*/ /*AND pD0101.NName IS NOT NULL*/ THEN  
    EinzelU_GbR(pD0101);
  --END IF;
  CASE
  WHEN vWKD_BEA.a0101_03_sid1 > 0 AND vWKD_BEA.a0101_03_sid1 <> vWKD_BEA.a0101_03_sid0 THEN  
    vWKD_BEA.a0101_03_CHK := 1;  -- Vorschlag bernehmen
--  WHEN vWKD_BEA.a0101_03_sid0 > 0 THEN
--    vWKD_BEA.a0101_03_CHK := 0;  -- original bleibt erhalten
  ELSE NULL;
  END CASE;
   
END;

PROCEDURE ChkBez_Art AS
  vSID INT;
BEGIN
  
  -- Rechtsform
--  CASE
--  WHEN vWKD_BEA.A0101_03_sid2 > -1 THEN -- manuell
--    vSID := vWKD_BEA.A0101_03_sid1;
--  
--  WHEN vWKD_BEA.A0101_03_sid1 > -1 AND vWKD_BEA.A0101_03_SID0 = -1 THEN 
--    vSID := vWKD_BEA.A0101_03_sid1;
--  ELSE 
--    vSID := vWKD_BEA.A0101_03_SID0;
--  END CASE;

  CASE
  WHEN vWKD_BEA.A0101_03_sid2 > -1 THEN -- manuell
    vSID := vWKD_BEA.A0101_03_sid1;  
  WHEN vWKD_BEA.A0101_03_sid1 > -1 THEN 
    vSID := vWKD_BEA.A0101_03_sid1;
  ELSE 
    vSID := vWKD_BEA.A0101_03_SID0;
  END CASE;
  
  CASE
  WHEN vSID IN (  1976001,  -- sonst. Natrl. Person
                2,        -- Einzelunternehmer
                434001)   -- eingetragener Kaufmann/frau 
  THEN
    vWKD_BEA.Bez_ART1 := 'N';
  WHEN vSID > -1 THEN 
    vWKD_BEA.BEZ_ART1 := 'F';
  ELSE
    vWKD_BEA.BEZ_ART1 := NULL;
  END CASE;

--  AddMsg('Adresstyp:');
--  CASE 
--  WHEN vWKD_BEA.bez_art0 IS NULL THEN
--    AddMsg(' - nicht vorhanden');
--  WHEN vWKD_BEA.bez_art0 = 'F' THEN
--    AddMsg(' - vorhanden: Firma');
--  WHEN vWKD_BEA.bez_art0 = 'N' THEN
--    AddMsg(' - vorhanden: Person');
--  ELSE
--    AddMsg(' - vorhanden: Fehler -> ' || vWKD_BEA.bez_art0);
--  END CASE;
--
--  IF vWKD_BEA.BEZ_ART1 IS NOT NULL 
--  AND  vWKD_BEA.BEZ_ART0 || CHR(9) <> vWKD_BEA.BEZ_ART1 || CHR(9) THEN
--    CASE vWKD_BEA.BEZ_ART1
--    WHEN 'F' THEN
--      AddMsg(' - Vorschlag: Firma');
--    WHEN 'N' THEN
--      AddMsg(' - Vorschlag: Person');
--    ELSE NULL;
--    END CASE;        
--  END IF; 
    
END;

PROCEDURE ChkBez(pD0101 IN vis_d0101%ROWTYPE) AS
vBez VARCHAR2(256);
vVorh INT := 0;
v1 VARCHAR2(256);
v2 VARCHAR2(256);
vCnt INT;
BEGIN

  -- 1.2.13 c) 1.)
  -- natrl. Person ohne abw. Betreiber -> Bez. generieren
  IF vWKD_BEA.bez_art1 = 'N' AND pD0101.ID = pD0101.D0101_ID3 
  AND pD0101.NName IS NOT NULL THEN
    -- Verarbeitung P_NAME
    vBez := REPLACE( UPPER(pD0101.p_name), ' ', NULL);  -- Leerzeichen entfernen
    v1 := REPLACE( UPPER(pD0101.NName), ' ', NULL);
    v2 := REPLACE( UPPER(pD0101.vname), ' ', NULL);
    
    IF v2 IS NOT NULL THEN -- Vorname vorhanden
      IF vBez = v1 || ',' || v2  -- Nachname, Vorname
      OR vBez = v2 || v1 THEN    -- Vorname Nachname
        vVorh := 1;
      END IF;
    -- nur Nachname ohne Vorname
    ELSIF vBez = v1 THEN
      vVorh := 1;
    END IF;    

    vWKD_BEA.p_name_chk := 0; 

    vWKD_BEA.p_name_1 := CreateD0102Bez( pD0101);
    IF vWKD_BEA.p_name_1 <> pD0101.p_name THEN
      vWKD_BEA.p_name_chk := 1;
    END IF;
    
    IF vVorh = 0 THEN  -- P_NAME nach P_NAME1 bertragen
      vWKD_BEA.p_name_chk := 2; 
      vWKD_BEA.p_name1_1 := pD0101.p_name || CASE WHEN pD0101.p_name1 IS NOT NULL THEN ', ' || pD0101.p_name1 END; 
    END IF;
    
    -- Verarbeitung BEZ
    vBez := REPLACE( UPPER(pD0101.bez), ' ', NULL);  -- Leerzeichen entfernen
    v1 := REPLACE( UPPER(pD0101.NName), ' ', NULL);
    v2 := REPLACE( UPPER(pD0101.vname), ' ', NULL);
    
    IF v2 IS NOT NULL THEN -- Vorname vorhanden
      IF vBez = v1 || ',' || v2  -- Nachname, Vorname
      OR vBez = v2 || v1 THEN    -- Vorname Nachname
        vVorh := 1;
      END IF;
    -- nur Nachname ohne Vorname
    ELSIF vBez = v1 THEN
      vVorh := 1;
    END IF;    

    vWKD_BEA.bez1 := CreateD0101Bez( pD0101);    
    IF vWKD_BEA.bez1 <> pD0101.bez THEN
      vWKD_BEA.bez_chk := 1; 
    ELSE
      vWKD_BEA.bez_chk := 0; 
    END IF;
    
    IF vVorh = 0 THEN  -- BEZ nach NAME bertragen
      vWKD_BEA.name1_chk := 1; 
      vWKD_BEA.name1_1 := pD0101.bez || CASE WHEN pD0101.name1 IS NOT NULL THEN ', ' || pD0101.name1 END; 
    ELSE
      vWKD_BEA.name1_chk := 0;
    END IF;    

  ELSIF vWKD_BEA.bez_art1 = 'F' THEN
    
    -- 1.2.13 c) 2.) p_name enthlt Vornamen
    -- alle durch Leerzeichen getrennte Token als List erstellen und mit a0081 vergleichen
    -- bei erfolgreichem Fund p_name = bez setzen
    IF vWKD_BEA.p_name_0 IS NOT NULL THEN
      vBez := REPLACE( REPLACE( vWKD_BEA.p_name_0, ',', ' '), '-', ' '); -- Komma und '-' entfernen
      
      SELECT COUNT(*) INTO vCnt
      FROM (
        SELECT REGEXP_SUBSTR(vBez, '[^,]+', 1, LEVEL) txt 
        FROM dual
        CONNECT BY REGEXP_SUBSTR(vBez, '[^,]+', 1, LEVEL) IS NOT NULL
      ) dx 
      JOIN vis_a0081 a0081 ON a0081.vname = dx.txt
      AND a0081.deleted = 0;
      
      IF vCnt > 0 THEN -- Vorname in p_name enthalten
        vWkd_bea.p_name1_1 := pD0101.p_name || CASE WHEN pD0101.p_name1 IS NOT NULL THEN ', ' || pD0101.p_name1 END;
        vWKD_bea.p_name_1 := pD0101.bez;
        vWKD_Bea.p_name_chk := 1;
      END IF;
  
    END IF;

    -- 1.2.13 c) 3. Rechtsform ermittelt
--    IF vWKD_BEA.Bez1_Field IS NOT NULL AND vWkd_Bea.bez0 <> vWKD_BEA.Bez1 THEN  -- Bez ber Rechtsform gefunden
--      vWKD_BEA.bez1 := vBez_neu;
--      vWKD_BEA.bez_chk := 1;
--      vWKD_BEA.name1_1 := pD0101.bez || CASE WHEN pD0101.name1 IS NOT NULL THEN ', ' || pD0101.name1 END;        
--    END IF; 
    
  END IF;  


  IF vWKD_BEA.bez0 <> vWKD_BEA.bez1 THEN
    AddMsg('Bezeichnung:');
    AddMsg(' - vorhanden: ' || vWKD_BEA.bez0);
    IF pD0101.NAME1 IS NOT NULL THEN
      AddMsg('              ' || vWKD_BEA.name1_0);
    END IF;
    
    AddMsg(' - Vorschlag: ' || vWKD_BEA.bez1);
    AddMsg('              ' || vWKD_BEA.name1_1);
             
  END IF;

END;

PROCEDURE ChkHV(pD0101 IN vis_d0101%ROWTYPE) AS
BEGIN

  -- Personal im Betrieb eingetragen
  IF pD0101.nname || pD0101.vname IS NOT NULL THEN 

    FOR c1 IN (
      SELECT d0102.nname, d0102.vname, d0102.vorsatz_nname, d0102.nachsatz_nname, d0102.titel, d0102.anrede
      FROM vis_d010200 d010200
      JOIN vis_d0102 d0102 ON d0102.id = d010200.d0102_id
      AND d010200.deleted = 0
      AND d0102.deleted = 0
      AND d010200.hauptansprechpartner = 1
      AND d010200.d0101_id = pD0101.id
    ) LOOP
      IF c1.nname || c1.vname || c1.nachsatz_nname || c1.vorsatz_nname || CHR(9) <>       
      pD0101.nname || pD0101.vname || pD0101.nachsatz_nname || pD0101.vorsatz_nname || CHR(9) THEN
      
        AddMsg('Hauptansprechpartner: Unterschiede im Personal und Betrieb - manuelle Bereinigung notwendig');
        AddMsg(' - Personal : ' || CreateD0102Bez(c1.anrede, c1.titel, c1.vname, c1.nname, c1.vorsatz_nname, c1.nachsatz_nname));
        AddMsg(' - Betrieb  : ' || CreateD0102Bez(pD0101.anrede, pD0101.titel, pD0101.vname, pD0101.nname, pD0101.vorsatz_nname, pD0101.nachsatz_nname));
        
      END IF;
      EXIT;
    END LOOP; 
  
  END IF;
END;

FUNCTION CrtResult RETURN NUMBER AS
 vRes NUMBER(1) := 0;
BEGIN
  
  IF (vWKD_BEA.A0101_03_sid1 = vWKD_BEA.A0101_03_SID0 AND vWKD_BEA.A0101_03_SID1 > -1) OR
    vWKD_BEA.A0101_03_SID0 > -1 THEN
    vRes := 1;
  END IF;
     
  -- BEZ_ART
  IF vRes = 1 AND vWKD_BEA.bez_art0 || CHR(9) <> vWKD_BEA.Bez_Art1 || CHR(9) THEN 
    vRes := 0;
  END IF; 
  
  IF vRes = 1 AND vWKD_BEA.bez0 || CHR(9) <> vWKD_BEA.bez1 || CHR(9) THEN
    vRes := 0;
  END IF;
  
  --vWKD_BEA.result := vRes;
 
  RETURN vRes;
END;

PROCEDURE FillResultMsg(pD0101 IN vis_d0101%ROWTYPE) AS
--vMsg VARCHAR2(4000) := NULL; 
--v1 VARCHAR2(1000);
--vD3_bez vis_d0101.bez%TYPE;
--vD3_name1 vis_d0101.name1%TYPE;
--vD3_p_name vis_d0101.p_name%TYPE;
--vD3_p_name1 vis_d0101.p_name1%TYPE;
--vD3_daten_herkunft vis_d0101.daten_herkunft%TYPE;
--vD3_a0101_03_sid vis_d0101.a0101_03_sid%TYPE;

--  PROCEDURE Add1(p1 IN VARCHAR2, pUnderline IN INT := 0, pTab IN INT := 0) AS
--  BEGIN
--    vMsg := vMsg || 
--            CASE WHEN pTab > 0 THEN RPAD(' ', pTab * 2) END || 
--            p1 || CrLf ||
--            CASE WHEN pUnderline = 1 THEN RPAD('', LENGTH(p1), '') || CrLf END;
--  END;

BEGIN

  vWKD_Bea.result_msg := vRegelMsg || CrLf;

--  IF pD0101.skz = 1 THEN
--    SELECT bez, name1, p_name, p_name1, daten_herkunft, a0101_03_sid
--    INTO vD3_bez, vD3_name1, vD3_p_name, vD3_p_name1, vD3_daten_herkunft, vD3_a0101_03_sid
--    FROM vis_d0101
--    WHERE id = pD0101.d0101_id3;
--  END IF;
--
--  Add1('Altdaten', 1);
--  
--  SELECT kurzb INTO v1 FROM vis_a0101 WHERE sid = vWKD_Bea.a0101_03_sid0;  
--  Add1('Rechtsform: ' || v1, 0, 1);
--  IF pD0101.skz = 1 THEN
--    Add1('Standortbezeichnung:', 0, 1);
--  ELSE
--    Add1('Bezeichnung:', 0, 1);
--    Add1(vWkd_bea.bez0, 0 , 2);
--  END IF;
--  IF vWkd_bea.name1_0 IS NOT NULL THEN
--    Add1(vWkd_bea.name1_0, 0 , 2);
--  END IF;
--  
--        
--  IF pD0101.skz = 1 THEN 
--    Add1(NULL);
--    Add1('Betreiber-Bezeichnung:',0,1);
--    Add1(vWKD_Bea.p_name_0,0, 2);
--    IF vWKD_BEA.p_name1_0 IS NOT NULL THEN
--      Add1(vWKD_Bea.p_name1_0,0, 2);
--    END IF;
--  END IF;       
--
--  Add1(NULL);
--  Add1('Hauptansprechpartner: ' || 
--      CreateD0102Bez(vWKD_Bea.anrede_0, vWKD_Bea.titel_0, vWKD_Bea.vname_0, vWKD_Bea.nname_0, NULL, NULL)
--        , 0, 1);  
--
--  --Add1( CrLf || RPAD('', 80, ''), 0, 0);
--
--  IF  vWKD_Bea.result < 1 THEN
--    Add1(CrLf||vRegelMsg);
--    Add1(CrLf||UPPER('Es ist keine automatische Bewertung und Bereinigung mglich!'),0, 0);
--  ELSE                    
--    -- Neu
--    IF vRegelMsg IS NOT NULL THEN
--      Add1(CrLf||'Vorschlag zur automatischen Bereinigung:');
--      Add1( vRegelMsg||CrLf, 0, 0);
--    END IF;
--    Add1('Bewertung: ' || CASE WHEN vWKD_Bea.result BETWEEN 2 AND 100 THEN vWKD_Bea.result || ' %'
--                               WHEN vWKD_Bea.result < 0 THEN UPPER('keine automatische Bewertung mglich')
--                               WHEN vWKD_Bea.result > 100 THEN '100 %'
--                           END, 0, 0);
--   
--    Add1(NULL);
--    
--    IF vD3_daten_herkunft = 'BEA' THEN
--      SELECT kurzb INTO v1 FROM vis_a0101 WHERE sid = vD3_a0101_03_sid;
--    ELSE    
--      SELECT kurzb INTO v1 FROM vis_a0101 WHERE sid = NVL(vWKD_Bea.a0101_03_sid1, -1);
--    END IF;  
--    Add1('Rechtsform: ' || v1, 0, 1);
--    IF pD0101.skz = 1 THEN
--      Add1('Standortbezeichnung:', 0, 1);
--    ELSE
--      Add1('Bezeichnung:', 0, 1);
--      Add1(vWkd_bea.bez1, 0 , 2);
--    END IF;
--    IF vWkd_bea.name1_1 IS NOT NULL THEN
--      Add1(vWkd_bea.name1_1, 0 , 2);
--    END IF;  
--
--    Add1(NULL);
--    Add1('Hauptansprechpartner: ' || 
--        CreateD0102Bez(vWKD_Bea.anrede_1, vWKD_Bea.titel_1, vWKD_Bea.vname_1, vWKD_Bea.nname_1, NULL, NULL)
--          , 0, 1);  
--    
--    IF pD0101.skz = 1 THEN
--      Add1(NULL);
--      Add1('Betreiber-Bezeichnung:',0,1);
--      IF vD3_daten_herkunft = 'BEA' THEN -- falls Betreiber schon bereinigt dann diese Daten anzeigen
--        Add1(vD3_p_name,0, 2);
--        IF vD3_p_name1 IS NOT NULL THEN
--          Add1(vD3_p_name1,0, 2);
--        END IF;      
--      ELSE
--        Add1(vWKD_Bea.p_name_1,0, 2);
--        IF vWKD_BEA.p_name1_1 IS NOT NULL THEN
--          Add1(vWKD_Bea.p_name1_1,0, 2);
--        END IF;
--      END IF;
--    END IF;
--  END IF;
--         
--  vWKD_Bea.result_msg := CASE WHEN vRegelMsg IS NOT NULL THEN vRegelMsg || CrLf END || vMsg;

END;

-- pD0101_ID : VIS_D0101.ID 
-- pInsert: 0/1 Standard 0, bei 1 werden nur die Daten in WKD_BEA ohne Prfung angelegt.
FUNCTION CheckD0101(pD0101_ID IN vis_d0101.id%TYPE, pInsert NUMBER := 0) RETURN NUMBER AS
vRes NUMBER(1);
vCnt INT;
vD0101 vis_d0101%ROWTYPE;
BEGIN
  vRegelMsg := NULL;
  vUser_sid := BLV_SYS.GET_USER_SID;  
  SELECT * INTO vD0101 
  FROM vis_d0101
  WHERE id = pD0101_id;

  IF vD0101.daten_herkunft = 'BEA' THEN -- kein analysieren durchfhren
    -- Eintrag in wkd_bea als OK aktualisieren
    UPDATE wkd_bea 
    SET result = 1
      , upd_date = SYSDATE
      , upd_user = vUser_sid
    WHERE d0101_id = pD0101_id
    AND result <> 1;
  ELSE
    SELECT COUNT(*) INTO vCnt
    FROM wkd_bea WHERE d0101_id = pD0101_ID;
    
    IF vCnt > 0 Then
      SELECT * INTO vWKD_BEA
      FROM wkd_bea WHERE d0101_id = pD0101_ID;
      
    ELSE
      vWKD_BEA := NULL;
      vWKD_BEA.ID := NULL;
      vWKD_BEA.ins_date := SYSDATE;
      vWKD_BEA.ins_user := vUser_SID;
      vWKD_BEA.d0101_id := pD0101_ID;
    END IF;
    
    
    -- mit Werten aus D0101 aktualisieren
    vWKD_BEA.mandant := vD0101.mandant;
    vWKD_BEA.upd_date := SYSDATE;
    vWKD_BEA.upd_user := vUser_SID;
    vWKD_BEA.deleted := 0;
    vWKD_BEA.A0101_03_SID0 := vD0101.A0101_03_SID;
    vWKD_BEA.A0101_03_SID1 := NULL;
    vWKD_BEA.A0101_03_CHK := 0;  
    vWKD_BEA.bez_art0 := vD0101.bez_art;
    vWKD_BEA.bez_art1 := NULL;  
    vWKD_BEA.result := 0;
    vWKD_BEA.bez := vD0101.bez;
    vWKD_BEA.code := vD0101.code;
    vWKD_BEA.result_msg := NULL;
    vWKD_BEA.BEZ0 := vD0101.bez;
    vWKD_BEA.BEZ1 := NULL;
    vWKD_BEA.BEZ_CHK := 0;
    vWKD_BEA.BEZ1_FIELD := NULL;
    
    vWKD_BEA.P_NAME_0 := vD0101.p_name;
    vWKD_BEA.P_NAME1_0 := vD0101.p_name1;
    vWKD_BEA.P_NAME_1 := NULL;
    vWKD_BEA.P_NAME1_1 := NULL;
    vWKD_BEA.P_NAME_CHK := 0;

    vWKD_BEA.vname_0  := vD0101.vname;
    vWKD_BEA.nname_0  := vD0101.nname;
    vWKD_BEA.name1_0  := vD0101.name1;
    vWKD_BEA.anrede_0 := vD0101.anrede;
    vWKD_BEA.titel_0  := vD0101.titel;

    vWKD_BEA.vname_1  := NULL;
    vWKD_BEA.nname_1  := NULL;
    vWKD_BEA.name1_1  := NULL;
    vWKD_BEA.anrede_1 := NULL;
    vWKD_BEA.titel_1  := NULL;
    vWKD_BEA.name1_CHK  := 0;

    IF pInsert = 0 THEN
      vWKD_BEA.result := -1;
      ChkRechtsform(vD0101);
      
      IF vWKD_BEA.A0101_03_SID0 > 0 OR vWKD_BEA.A0101_03_SID1 > 0 OR vWKD_BEA.A0101_03_SID2 > 0 THEN
        ChkBez_Art();
      END IF;
      
      FillResultMsg(vD0101);
      --ChkHV(); 
      --ChkBez();
      
      --vRes := CrtResult();
      vRes := 0; 
    ELSE
      vWKD_BEA.result := -1;
      vWKD_BEA.result_msg := 'Der Betrieb wurde noch nicht geprft, deshalb ist die automatische Bereinigung nicht mglich.';
    END IF;
     
    IF vWKD_BEA.ID <> '-1' THEN  -- UPDATE
      UPDATE wkd_bea
      SET row = vWKD_BEA
      WHERE id = vWKD_BEA.ID;
      
    ELSE -- INSERT
      vWKD_BEA.ID := SYS_GUID();
      INSERT INTO wkd_bea VALUES vWKD_BEA;
       
    END IF;
  END IF; -- IF BEA  
  RETURN vRes;
  
END;  

-- pModus : 0 Anzeige alte und neue Werte, 1 nur neue Werte
FUNCTION AufbereitungResultMsg(pD0101 IN vis_d0101%ROWTYPE, pModus IN INT) RETURN VARCHAR2 AS
vMsg VARCHAR2(4000) := NULL; 
v1 VARCHAR2(1000);
vD3_bez vis_d0101.bez%TYPE;
vD3_name1 vis_d0101.name1%TYPE;
--vD3_p_name vis_d0101.p_name%TYPE;
--vD3_p_name1 vis_d0101.p_name1%TYPE;
vD3_daten_herkunft vis_d0101.daten_herkunft%TYPE;
vD3_a0101_03_sid vis_d0101.a0101_03_sid%TYPE;
vBEA wkd_bea%ROWTYPE;
--vBEA_3 wkd_bea%ROWTYPE;  -- Betreiber

  PROCEDURE Add1(p1 IN VARCHAR2, pUnderline IN INT := 0, pTab IN INT := 0) AS
  BEGIN
    vMsg := vMsg || 
            CASE WHEN pTab > 0 THEN RPAD(' ', pTab * 2) END || 
            p1 || CrLf ||
            CASE WHEN pUnderline = 1 THEN RPAD('', LENGTH(p1), '') || CrLf END;
  END;

BEGIN

  IF pModus = 1 THEN
  
    SELECT kurzb INTO v1 FROM vis_a0101 WHERE sid = pD0101.a0101_03_sid;
    Add1('Rechtsform: ' || v1, 0, 1);
    
    IF pD0101.skz = 1 THEN
      Add1('Standortbezeichnung:', 0, 1);
    ELSE
      Add1('Bezeichnung:', 0, 1);
      Add1(pD0101.bez, 0 , 2);
    END IF;
    
    IF pD0101.name1 IS NOT NULL THEN
      Add1(pD0101.name1, 0 , 2);
    END IF;  

    Add1(NULL);
    Add1('Hauptansprechpartner: ' || 
        CreateD0102Bez(pD0101.anrede, pD0101.titel, pD0101.vname, pD0101.nname, pD0101.vorsatz_nname, pD0101.nachsatz_nname)
          , 0, 1);  
  
  ELSE

    BEGIN
      SELECT dx.* INTO vBEA
      FROM wkd_bea dx WHERE dx.d0101_id = pD0101.id;
      EXCEPTION 
      WHEN NO_DATA_FOUND THEN vBEA.ID := '-11';
    END;
    
    IF vBEA.ID IN( '-11') THEN
      IF pD0101.daten_herkunft = 'BEA' THEN
        Add1( 'Der Betrieb ist BEA konform.');
      ELSE
        Add1( 'Der Betrieb muss noch fr die Bereinigung analysiert werden.');
      END IF;
    ELSE

      IF pD0101.skz = 1 THEN
        SELECT bez, name1, daten_herkunft, a0101_03_sid
        INTO vD3_bez, vD3_name1, vD3_daten_herkunft, vD3_a0101_03_sid
        FROM vis_d0101
        WHERE id = pD0101.d0101_id3;
      END IF;

      Add1('Altdaten', 1);
        
      SELECT kurzb INTO v1 FROM vis_a0101 WHERE sid = vBEA.a0101_03_sid0;  
      Add1('Rechtsform: ' || v1, 0, 1);
      IF pD0101.skz = 1 THEN
        Add1('Standortbezeichnung:', 0, 1);
        Add1(pD0101.bez, 0 , 2);
      ELSE
        Add1('Bezeichnung:', 0, 1);
        Add1(pD0101.bez, 0 , 2);
      END IF;
      IF pD0101.name1 IS NOT NULL THEN
        Add1(pD0101.name1, 0 , 2);
      END IF;
        
              
      IF pD0101.skz = 1 AND pD0101.id = pD0101.d0101_id3 THEN 
        Add1(NULL);
        Add1('Betreiber-Bezeichnung:',0,1);
        Add1(vBEA.bez0,0, 2);
        IF vBEA.name1_0 IS NOT NULL THEN
          Add1(vBEA.name1_0,0, 2);
        END IF;
      END IF;       

      Add1(NULL);
      Add1('Hauptansprechpartner: ' || 
  --        CreateD0102Bez(vBEA.anrede_0, vBEA.titel_0, vBEA.vname_0, vBEA.nname_0, NULL, NULL)
  --          , 0, 1);  
          CreateD0102Bez(pD0101.anrede, pD0101.titel, pD0101.vname, pD0101.nname, NULL, NULL)
            , 0, 1);  

      
      v1 := dbo.get_token(vBEA.result_msg, 1, CrLf);

      IF  vBEA.result < 1 THEN
        IF v1 IS NOT NULL THEN
          Add1(CrLf||v1);
        END IF;
        Add1(CrLf||UPPER('Es ist keine automatische Bewertung und Bereinigung mglich!'),0, 0);
      ELSE                    
       IF pModus = 0 THEN
          -- Neu
          IF v1 IS NOT NULL THEN
            Add1(CrLf||'Vorschlag zur automatischen Bereinigung:', 1);
            Add1( v1, 0, 0);
          END IF;
          Add1('Bewertung: ' || CASE WHEN vBEA.result BETWEEN 2 AND 100 THEN vBEA.result || ' %'
                                     WHEN vBEA.result < 0 THEN UPPER('keine automatische Bewertung mglich')
                                     WHEN vBEA.result > 100 THEN '100 %'
                                 END, 0, 0);
         
          Add1(NULL);
        END IF;
        
        IF vD3_daten_herkunft = 'BEA' THEN
          SELECT kurzb INTO v1 FROM vis_a0101 WHERE sid = vD3_a0101_03_sid;
        ELSE    
          SELECT kurzb INTO v1 FROM vis_a0101 WHERE sid = NVL(vBEA.a0101_03_sid1, -1);
        END IF;  
        Add1('Rechtsform: ' || v1, 0, 1);
        IF pD0101.skz = 1 THEN
          Add1('Standortbezeichnung:', 0, 1);
        ELSE
          Add1('Bezeichnung:', 0, 1);
          Add1(vBEA.bez1, 0 , 2);
        END IF;
        IF vBEA.name1_1 IS NOT NULL THEN
          Add1(vBEA.name1_1, 0 , 2);
        END IF;  

        Add1(NULL);
        Add1('Hauptansprechpartner: ' || 
            CreateD0102Bez(vBEA.anrede_1, vBEA.titel_1, vBEA.vname_1, vBEA.nname_1, NULL, NULL)
              , 0, 1);  
        
        IF pD0101.skz = 1 AND pD0101.ID = pD0101.d0101_id3 THEN
          Add1(NULL);
          Add1('Betreiber-Bezeichnung:',0,1);
          IF vD3_daten_herkunft = 'BEA' THEN -- falls Betreiber schon bereinigt dann diese Daten anzeigen
            Add1(vD3_bez,0, 2);
            IF vD3_name1 IS NOT NULL THEN
              Add1(vD3_name1,0, 2);
            END IF;      
          ELSE
            Add1(vBEA.bez1,0, 2);
            --IF vBEA.p_name1 IS NOT NULL THEN
            --  Add1(vBEA.p_name1_1,0, 2);
            --END IF;
          END IF;
        END IF;
      END IF;
    END IF;
    
  END IF; -- pModus = 1       
  
  RETURN vMsg;

END AufbereitungResultMsg; 


-- Dynamische Aufbereitung der Information aus WKD_BEA
FUNCTION D0101CheckMsg(pD0101_ID IN vis_d0101.id%TYPE) RETURN CLOB AS
vResult3 wkd_bea.result%TYPE;
vRes CLOB := NULL;
vD0101 vis_d0101%ROWTYPE;
vD0101_3 vis_d0101%ROWTYPE;
BEGIN
 
  SELECT dx.* INTO vD0101
  FROM vis_d0101 dx WHERE dx.id = pD0101_ID;
  
  IF vD0101.ID <> vD0101.d0101_id3 THEN
    SELECT MAX(dx.result) INTO vResult3
    FROM wkd_bea dx WHERE dx.d0101_id = vD0101.d0101_id3;

    SELECT * INTO vD0101_3
    FROM vis_d0101 WHERE id = vD0101.d0101_id3;

    CASE 
    WHEN vResult3 IS NULL AND NVL(vD0101_3.daten_herkunft, 'x') <> 'BEA' THEN   
      vRes := CrLf||
              UPPER('Der Betreiber muss noch fr die Bereinigung analysiert werden!')||CrLf||
              UPPER('Die automatische Bereinigung ist nicht mglich!')||CrLf||
              LPAD('', 80, '')||CrLf; 
    WHEN vResult3 <> 1 THEN
      vRes := CrLf||
              UPPER('Der Betreiber ist noch nicht bereinigt!')||CrLf||
              UPPER('Die automatische Bereinigung ist nicht mglich!')||CrLf||
              LPAD('', 80, '')||CrLf; 
    ELSE NULL;
    END CASE;        
  END IF;
  
  vRes := vRes ||
          CASE WHEN vD0101.skz = 1 
          THEN 'Betriebssttte' || CrLf ||
               '' || CrLf 
          ELSE 'Betreiber' || CrLf ||
               '' || CrLf
          END || AufbereitungResultMsg(vD0101, 0);
   
  IF vD0101.D0101_ID3 <> vD0101.ID THEN -- abweichender Betreiber
   
    SELECT dx.* INTO vD0101_3
    FROM vis_d0101 dx WHERE dx.id = vD0101.D0101_ID3;
    
    vRes := CASE WHEN vRes IS NOT NULL THEN vRes || CrLf || CrLf END || 
            LPAD('', 80, '') || CrLf ||
            'Betreiber' || CrLf ||
            '' || CrLf || 
            AufbereitungResultMsg(vD0101_3, 
                                  CASE WHEN vResult3 <> 1 THEN 0 ELSE 1 END);
            
  END IF;
    
  RETURN vRes;

END;

-- Information aus WKD_BEA auslesen
FUNCTION D0101CheckMsg_old(pD0101_ID IN vis_d0101.id%TYPE) RETURN CLOB AS
vMsg1 wkd_bea.result_msg%TYPE;
vMsg3 wkd_bea.result_msg%TYPE;
vResult1 wkd_bea.result%TYPE;
vResult3 wkd_bea.result%TYPE;
vD0101_ID3 vis_d0101.d0101_id3%TYPE;
vRes CLOB := NULL;
BEGIN

  SELECT MAX(d1.Result) d1_result, MAX(d3.result) d3_result, MAX(d1.Result_msg) d1_msg, MAX(d3.result_msg) d3_msg, MAX(d0101.d0101_id3)  
  INTO vResult1, vResult3, vMsg1, vMsg3, vD0101_ID3
  FROM vis_d0101 d0101
  LEFT JOIN wkd_bea d1 ON d1.d0101_id = d0101.id
  LEFT JOIN wkd_bea d3 ON d3.d0101_id = CASE WHEN d0101.d0101_id3 = '-1' THEN d0101.id ELSE d0101.d0101_id3 END
  WHERE d0101.id = pD0101_ID;
  
  IF pD0101_ID <> vD0101_id3 AND vResult3 <> 1 THEN
    vRes := CrLf||
            UPPER('Der Betreiber ist noch nicht bereinigt!')||CrLf||
            UPPER('Die automatische Bereinigung ist nicht mglich!')||CrLf||
            LPAD('', 80, '')||CrLf; 
            
  END IF;
  IF vMsg1 IS NOT NULL THEN  -- fr Betriebssttte
    vRes := vRes ||
            'Betriebssttte' || CrLf ||
            '' || CrLf || SUBSTR(vMsg1, INSTR(vMsg1, CrLf) + 2); -- Regel entfernen
  END IF;
   
  IF vD0101_ID3 <> pD0101_ID AND vMsg3 IS NOT NULL THEN -- abweichender Betreiber
 
    vRes := CASE WHEN vRes IS NOT NULL THEN vRes || CrLf || CrLf END || 
            LPAD('', 80, '') || CrLf ||
            'Betreiber' || CrLf ||
            '' || CrLf || SUBSTR(vMsg3, INSTR(vMsg3, CrLf) + 2); -- Regel entfernen
  END IF;
    
  RETURN vRes;

END;

FUNCTION ChkBetreiberBearbeiten RETURN INT DETERMINISTIC AS
vS07_code CONSTANT vis_s07.code%TYPE := 'OPTIONS';
vS0701_Code CONSTANT vis_s07.code%TYPE := 'BetreiberBearbeitenNurEigenerMandant';
vWert vis_s0702.wert%TYPE;
vRes INT := 0; 
BEGIN  

  SELECT MAX(s07.wert) 
  INTO vWert
  FROM vis_vs07 s07
  WHERE s07.s07_code = vS07_Code
  AND s07.s0701_code = vS0701_Code;

  IF vWert = 1 THEN 
    vRes := 1;
  END IF;
  RETURN vRes;
END;

-- Ist Betrieb bereits in Ordnung 
-- pCheck = 1: falls Betrieb nicht in wkd_bea dann wird die Prfung autom. ausgefhrt 
--             und in wkd_bea gespeichert
-- RESULT : 
--  0 : autom. Bereinigung mglich
--  -1 : autom. Bereinigung nicht mglich
FUNCTION D0101CheckResult(pD0101_ID IN vis_d0101.id%TYPE, pCheck IN NUMBER := 0) RETURN NUMBER AS
vRes INT := -1;
--vCnt INT := 0;
vResult1 wkd_bea.result%TYPE;
vResult3 wkd_bea.result%TYPE;
vDaten_herkunft1 vis_d0101.daten_herkunft%TYPE;
vDaten_herkunft3 vis_d0101.daten_herkunft%TYPE;
vSKZ3 vis_d0101.skz%TYPE;
vD0101_ID3 vis_d0101.d0101_id3%TYPE;
vMandant3 vis_d0101.mandant%TYPE;
BEGIN


  --11.08.2014 SELECT MAX(d1.Result) d1_result, MAX(d3.result) d3_result, MAX(d0101.d0101_id3)
  --, MAX(d0101.daten_herkunft), MAX(d0101_3.daten_herkunft)  
  SELECT d1.Result, d3.result, d0101.d0101_id3
  , d0101.daten_herkunft, d0101_3.daten_herkunft
  , d0101_3.mandant, d0101_3.skz
  INTO vResult1, vResult3, vD0101_ID3, vDaten_herkunft1, vDaten_herkunft3
  , vMandant3, vSKZ3
  FROM vis_d0101 d0101
  JOIN vis_d0101 d0101_3 ON d0101_3.id = CASE WHEN d0101.d0101_id3 = '-1' THEN d0101.id ELSE d0101.d0101_id3 END
  LEFT JOIN wkd_bea d1 ON d1.d0101_id = d0101.id
  LEFT JOIN wkd_bea d3 ON d3.d0101_id = CASE WHEN d0101.d0101_id3 = '-1' THEN d0101.id ELSE d0101.d0101_id3 END
  WHERE d0101.id = pD0101_ID
  AND rownum = 1;

  CASE
  -- 20.05.2014 neue Anforderung
  -- wenn Betrieb und Betreiber BEA dann immer OK
  WHEN vDaten_herkunft1 = 'BEA' AND vDaten_herkunft3 = 'BEA' THEN     
    vRes := 1;
  WHEN vResult1 = -1 OR vResult3 = -1 THEN
    vRes := -1;
  WHEN vResult1 = 1 AND vResult3 = 1 THEN --kann nicht mehr auftreten
    vRes := 1;

  WHEN vResult1 > 1 AND vDaten_herkunft3 = 'BEA' AND vD0101_ID3 <> pD0101_ID THEN -- 15.10.2014    
    vRes := 0;
    
  WHEN vResult1 = 1 AND NVL(vResult3, 0) <> 1 AND vD0101_ID3 <> pD0101_ID THEN -- abweichende Betreiber ist noch nicht bereinigt
    --11.08.2014
    --abweichender Betreiber ist SKZ=1 oder vom anderen Mandanten und man kann nur 
    --seine eigenen Betreiber bearbeiten, dann Freigabe fr BEA
    --wird in BEA geregelt, dass dann der Betreiber nicht gendert werden kann  
    IF vSKZ3 = 1 OR 
    ( vMandant3 <> BLV_SYS.GET_MANDANT AND ChkBetreiberBearbeiten() = 1) THEN 
      vRes := 1;    
    ELSE
      vRes := -1;
    END IF;
  WHEN vResult1 > 1 AND NVL(vResult3, 0) <> 1 AND vD0101_ID3 <> pD0101_ID THEN -- 18.09.2014
    vRes := -1;       
  WHEN (vResult1 IS NULL OR vResult3 IS NULL) AND vD0101_ID3 <> pD0101_ID  THEN -- 22.10.2014 nur bei abweichendem Betreiber
    vRes := -1;
    
    IF vDaten_herkunft1 = 'BEA' AND NVL(vResult1,1) = 1 AND
    vDaten_herkunft3 = 'BEA' AND NVL(vResult3,1) = 1 THEN
      vRes := 1;
    -- 22.10.2014 ELSE      
    -- 22.10.2014  vRes := 0;
    END IF;
  
  WHEN vResult1 > 1 AND vResult3 = 1 THEN  -- 18.09.2014    
    vRes := 0;     
  WHEN pD0101_ID = vD0101_ID3 AND vSKZ3 = 99 AND vResult1 > 1 
  AND (vMandant3 = BLV_SYS.GET_MANDANT OR ChkBetreiberBearbeiten() = 0)  THEN -- 18.09.2014   
    vRes := 0;
  WHEN (vSKZ3 = 1 AND vD0101_ID3 <> pD0101_ID) OR 
    ( vMandant3 <> BLV_SYS.GET_MANDANT AND ChkBetreiberBearbeiten() = 1) THEN 
      vRes := -1;    
  WHEN vResult1 > 1 THEN    
      vRes := 0;  
  ELSE
    vRes := -1;
  END CASE;   

  IF vRes = 0 AND pCheck = 1 THEN -- sofort berprfen
    IF CheckD0101(pD0101_ID) = 1 THEN
      vRes := 1;
    ELSE   
      vRes := 0;
    END IF;
  END IF;
  
  RETURN vRes;

END;

FUNCTION D0101IsChecked(pD0101_ID IN vis_d0101.id%TYPE, pCheck IN NUMBER := 0) RETURN NUMBER AS
BEGIN
  RETURN D0101CheckResult(pD0101_ID, pCheck);
END;

PROCEDURE AddRepairMsg(p1 IN VARCHAR2) AS
BEGIN
  vRepairMsg := vRepairMsg || p1 || CrLf;
END;
PROCEDURE IncRepairErrCnt AS
BEGIN
  vRepairErrCnt := vRepairErrCnt + 1;
END;

PROCEDURE CrtHit_bez(pBez IN vis_d0101.bez%TYPE, pHIT1 OUT NOCOPY vis_d0101.hit_bez_1%TYPE, pHIT2 OUT NOCOPY vis_d0101.hit_bez_1%TYPE) AS
v0 INT;
v1 INT;
v2 INT;
v30 VARCHAR2(30);
TYPE tTZ IS TABLE OF VARCHAR2(1 CHAR);
vTZ tTZ := tTZ( '-', ',', '.', ':', '/', ';', '&'); 
BEGIN
  IF NVL( LENGTH(pBEZ), 0) <= 30 THEN
    pHIT1 := NULL;
    pHIT2 := NULL;
  ELSE
    v1 := 0;
    v30 := SUBSTR(pBez,1,30);
    FOR i IN vTZ.FIRST .. vTZ.LAST LOOP    
      v0 := INSTR( v30, vTZ(i), -1);
      IF v0 > v1 THEN
        v1 := v0;
      END IF;
    END LOOP;

    v2 := INSTR( SUBSTR(pBez,1,30), ' ', -1);
    
    CASE
    WHEN v1 > v2 THEN -- '-' Trennzeichen
      pHIT1 := SUBSTR(pBez, 1, v1);
      pHIT2 := LTRIM(SUBSTR(pBez, v1+1, 30));
    WHEN v2 > v1 THEN  -- ' ' Trennzeichen
      pHIT1 := SUBSTR(pBez, 1, v2-1);
      pHIT2 := LTRIM(SUBSTR(pBez, v2, 30));
    ELSE
      pHIT1 := SUBSTR(pBez, 1, 30);
      pHIT2 := LTRIM(SUBSTR(pBez, 31, 30));      
    END CASE;
    
  END IF;   

END;
 
-- Repariert Betrieb entsprechend den Prfungsergebnissen in WKD_BEA
PROCEDURE RepairD0101(pD0101_ID IN vis_d0101.id%TYPE, pBatch IN INT := 0) AS
vResult INT;
vDaten_herkunft vis_d0101.daten_herkunft%TYPE;
vOK INT := 1;
vSKZ INT;
vD0101 vis_d0101%ROWTYPE;
vMsgTrigger INT;
vA0101_03_SID INTEGER;
vCntBtr INTEGER := 0;
TYPE trID IS RECORD ( id vis_d0101.id%TYPE, daten_herkunft vis_d0101.daten_herkunft%TYPE );
TYPE tID IS TABLE OF trID;
vD0101_IDs tID;
vSYSDATE DATE := SYSDATE;
vD0101_ID3 vis_d0101.d0101_id3%TYPE;
BEGIN
  vUser_sid := BLV_SYS.GET_USER_SID;
  vRepairMsg := NULL;
  vRepairErrCnt := 0;
  BEGIN
    SELECT dx.* INTO vWKD_BEA
    FROM wkd_bea dx
    WHERE dx.d0101_id = pD0101_ID;
    EXCEPTION WHEN NO_DATA_FOUND THEN 
      vWKD_BEA.ID := NULL;
      IncRepairErrCnt;
      AddRepairMsg('Die Betriebssttte/der Betreiber knnen nicht autom. bereinigt werden. Die Analyse wurde noch nicht durchgefhrt.');
  END;
  
  IF vWKD_BEA.id IS NULL THEN
    RETURN;
  END IF;
  
  IF vWKD_BEa.result = 1 THEN
    IncRepairErrCnt;
    AddRepairMsg('Die Betriebssttte/der Betreiber sind bereits bereinigt.'); 
  ELSE   

    vMsgTrigger := blv_sys.get_EnabledMsgTrigger();
    blv_sys.set_EnabledMsgTrigger(0); -- Meldungstrigger ausschalten
      
    SELECT * INTO vD0101
    FROM vis_d0101
    WHERE id = pD0101_id;

    -- todo 56028090 12.11.2014
    vMandant_Sid := vD0101.Mandant;
    vUser_Sid := blv_sys.get_user_sid;

    IF vD0101.id <> vD0101.d0101_id3 AND vD0101.d0101_id3 <> '-1' THEN -- abweichender Betreiber
      -- berprfung Bereinigung Betreiber
      SELECT d0101.daten_herkunft, bea.result
      INTO vDaten_herkunft, vResult
      FROM vis_d0101 d0101
      LEFT JOIN wkd_bea bea ON bea.d0101_id = d0101.id
      WHERE d0101.id = vD0101.d0101_id3;
      
      CASE
      WHEN vDaten_herkunft = 'BEA' AND NVL( vResult, 1) = 1 THEN
        vOK := 1; -- Betreiber ist OK
      WHEN NVL(vDaten_herkunft, CHR(9)) <> 'BEA' AND vResult IS NULL THEN 
        AddRepairMsg('Der Betreiber wurde noch nicht analysiert und kann deshalb nicht automatisch bereinigt werden.');
        IncRepairErrCnt();
        vOK := 0;
      ELSE
        AddRepairMsg('Der Betreiber wurde noch nicht bereinigt.');
        IncRepairErrCnt();
        vOK := 0;
      END CASE;
      
    END IF; 
    
    IF vOK = 1 THEN
          
      vD0101.a0101_03_sid := NVL(vWkd_bea.a0101_03_sid1, -1); -- bei BTS gibt es keine Rechtsform
      vD0101.name1 := vWKD_Bea.name1_1;
      vD0101.p_name1 := vWKD_Bea.p_name1_1;
      vD0101.titel := vWkd_bea.titel_1;
      vD0101.vname := vWkd_bea.vname_1;
      vD0101.nname := vWkd_bea.nname_1;
      vD0101.anrede := vWkd_bea.anrede_1;
      vD0101.bez_art := vWkd_bea.bez_art1; 
      vD0101.daten_herkunft := 'BEA';     
      vD0101.upd_date := SYSDATE;
      vD0101.upd_user := vUser_sid;
      
      IF vD0101.id <> vD0101.d0101_id3 THEN  -- Werte vom abweichenden Betreiber
        SELECT bez, p_name, hit_bez_1, hit_bez_2, p_anrede , p_anrede, a0101_03_sid
        INTO vD0101.bez, vD0101.p_name, vD0101.hit_bez_1, vD0101.hit_bez_2, vD0101.p_anrede, vD0101.f_anrede, vA0101_03_sid -- 18.09.2014
        FROM vis_d0101 WHERE id = vD0101.d0101_id3;
        vD0101.d0101_id2 := vD0101.d0101_id3; -- 15.09.2014 Post immer an Betreiber
        
        IF vD0101.p_anrede IS NOT NULL AND GetRechtsformTyp(vA0101_03_sid) = 'N' THEN
          vD0101.briefanrede := GetBriefanrede(vD0101.p_anrede);
        END IF;
        
      ELSE
        vD0101.bez := vWKD_Bea.bez1;
        vD0101.p_name := vWkd_bea.p_name_1; 
        vD0101.p_anrede := vWkd_bea.anrede_1; -- 18.09.2014
        vD0101.f_anrede := vWkd_bea.anrede_1; -- 18.09.2014
        CrtHit_Bez(vD0101.bez, vD0101.hit_bez_1, vD0101.hit_bez_2); 
        IF vD0101.p_anrede IS NOT NULL AND GetRechtsformTyp(vD0101.A0101_03_sid) = 'N' THEN
          vD0101.briefanrede := GetBriefanrede(vD0101.p_anrede);
        END IF;
      END IF;

      vSKZ := vD0101.SKZ;
      
      UPDATE vis_d0101 SET ROW = vD0101
      WHERE id = pD0101_id;
      
      IF vD0101.SKZ = 1 THEN
        AddRepairMsg('Betriebssttte');
        AddRepairMsg('');
      ELSE
        AddRepairMsg('Betreiber');
        AddRepairMsg('');    
        AddRepairMsg(vD0101.bez );
      END IF;  
      IF vD0101.name1 IS NOT NULL THEN 
        AddRepairmsg( vD0101.name1 );
      END IF;
      AddRepairMsg(vD0101.strasse || ' ' || vD0101.hausnr||' '||vD0101.hausnrzusatz);
      AddRepairMsg(vD0101.PLZ || ' ' || vD0101.ort || ' ' || vD0101.ortsteil);

      vWkd_Bea.result := 1;
      UPDATE wkd_bea 
      SET result = 1
        , upd_date = SYSDATE
        , upd_user = vUser_sid 
      WHERE id = vWkd_bea.id;

      --vD0101_3 := NULL;
      -- kein abweichender Betreiber 
      CASE
      WHEN vD0101.SKZ = 1 AND vD0101.d0101_id3 IN ( vD0101.id, '-1') THEN
        SplitOperator(pD0101_id, 1); -- Betreiber trennen
        
        -- Inhaber im Personal der Betriebssttte zurcksetzen
        UPDATE vis_d010200
        SET inhaber = 0
          , upd_date = SYSDATE
          , upd_user = vUser_sid
        WHERE d0101_id = vD0101.id
        AND deleted = 0
        AND inhaber = 1;
         
      WHEN vD0101.skz IN (98,99) AND GetRechtsformTyp(vD0101.a0101_03_sid) = 'N' THEN
        IF vWKD_BEA.result_msg LIKE '2.10%' OR vWKD_BEA.result_msg LIKE '2.11%' THEN
          Personal_N(vD0101, vD0101, 1);
        ELSE
          Personal_N(vD0101, vD0101, 0);
        END IF;
      ELSE NULL;
      END CASE;    
      
      IF vSKZ = 1 THEN -- war Betriebssttte dann auch Betreiber anzeigen
        AddRepairMsg(NULL);
        AddRepairMsg('Betreiber');
        AddRepairMsg('');    
        
        DECLARE vD3 vis_d0101%ROWTYPE;
        BEGIN
          SELECT d3.* INTO vD3 
          FROM vis_d0101 d1
          JOIN vis_d0101 d3 ON d3.id = d1.d0101_id3 
          AND d1.id = pD0101_ID;
          
          AddRepairMsg(vD3.bez );
          IF vD3.p_name1 IS NOT NULL THEN
            AddRepairMsg( vD3.p_name1 );
          END IF; 
          AddRepairMsg(vD3.strasse || ' ' || vD3.hausnr||' '|| vD3.hausnrzusatz);
          AddRepairMsg(vD3.PLZ || ' ' || vD3.ort || ' ' || vD3.ortsteil);
        END;      
        
      END IF;               
            
      -- 21.10.2014 todo 55758090 - Neue Analyse der Betriebssttten
      IF vD0101.skz IN(99) THEN
        FOR c1 IN (
          SELECT d0101.id
          FROM vis_d0101 d0101
          WHERE d0101.deleted = 0
          AND d0101.d0101_id3 = vD0101.id
          AND d0101.id <> d0101.d0101_id3
          AND NVL(d0101.daten_herkunft, 'x') <> 'BEA' 
        ) LOOP
          IF CheckD0101(c1.id) > 0 THEN NULL; END IF;
        END LOOP;
      
      ELSIF vD0101.skz = 1 THEN  -- 22.10.2014

        SELECT COUNT(*) INTO vCntBtr
        FROM vis_d0101 dx 
        WHERE dx.deleted = 0
          AND dx.id <> dx.d0101_id3
          AND dx.d0101_id3 = pD0101_id;
        
        IF vCntBtr > 0 THEN -- Bts als Betreiber verwendet
          -- Betreiber den Betriebssttten zuordnen 
          SELECT d0101_id3 INTO vD0101_ID3
          FROM vis_d0101
          WHERE id = pD0101_ID;
          
          UPDATE (
            SELECT d1.id, d1.daten_herkunft, d1.upd_date, d1.upd_user
            , d1.d0101_id3, d1.d0101_id2
            , d3.d0101_id3 d0101_id3_neu
            FROM vis_d0101 d1
            JOIN vis_d0101 d3 ON d3.id = d1.d0101_id3
            AND d1.deleted = 0
            AND d1.id <> d1.d0101_id3 
            AND d3.id = vD0101.id )
          SET d0101_id3 = D0101_id3_neu
            , d0101_id2 = D0101_id3_neu
            , upd_date = vSYSDATE
            , upd_user = vUser_SID    
          --WHERE d0101_id3 = vD0101.ID  --22.10.2014 vD0101_D0101_ID3
          --AND deleted = 0
          RETURNING id, daten_herkunft BULK COLLECT INTO vD0101_IDs;
          
          IF vD0101_IDs.COUNT > 0 THEN

            -- Betreiberdaten auf Betriebssttte bertragen
            FORALL i IN vD0101_IDs.FIRST .. vD0101_IDs.LAST 
              UPDATE ( 
                SELECT d1.bez, d1.p_name, d1.hit_bez_1, d1.hit_bez_2
                  , d3.bez bez_3, d3.p_name p_name_3, d3.hit_bez_1 hit_bez_1_3, d3.hit_bez_2 hit_bez_2_3
                FROM vis_d0101 d1
                JOIN vis_d0101 d3 ON d3.id = d1.d0101_id3 -- Betreiberdaten
                AND d1.deleted = 0 
                AND d1.daten_herkunft = 'BEA'
                AND d1.skz = 1
                AND d1.id <> pD0101_ID
                AND d1.id =  vD0101_IDs(i).id )
              SET bez = bez_3
                , p_name = p_name_3
                , HIT_BEZ_1 = HIT_BEZ_1_3
                , HIT_BEZ_2 = HIT_BEZ_2_3;    
            --END LOOP;

            -- Ttigkeiten - Betreiber aktualisieren
            FORALL i IN vD0101_IDs.FIRST .. vD0101_IDs.LAST 
              UPDATE vis_d010801
              SET d0101_id4 = vD0101_ID3 -- neuer Betreiber
                , upd_date = vSYSDATE
                , upd_user = vUser_sid
              WHERE d0101_id = vD0101_IDs(i).ID
              AND deleted = 0
              AND d0101_id4 = pD0101_id ;
            --END LOOP;
            
            -- 21.10.2014 todo 55758090 - Neue Analyse der Betriebssttten
            FOR i IN vD0101_IDs.FIRST .. vD0101_IDs.LAST LOOP
              IF vD0101_IDs(i).id <> vD0101.ID AND NVL(vD0101_IDs(i).daten_herkunft, 'x') <> 'BEA' THEN
                IF CheckD0101(vD0101_IDs(i).id) > 0 THEN NULL; END IF;
              END IF;
            END LOOP;
          END IF;      
        END IF; -- vCntBtr      
      END IF;
    END IF; -- vOK = 1

    blv_sys.set_EnabledMsgTrigger(vMsgTrigger);
  END IF;

  vWKD_BEA := NULL;
  vD0101 := NULL;
END RepairD0101;

-- liefert Anzahl der entstandenen Fehler bei RepairD0101 
FUNCTION RepairD0101ErrCount RETURN NUMBER AS 
BEGIN
  RETURN vRepairErrCnt;
END;
-- liefert Fehler und Hinweise aus RepairD0101 
FUNCTION RepairD0101Msg RETURN VARCHAR2 AS
BEGIN
  RETURN vRepairMsg;
END;


-- Nummern/Zulassungen/Registrierungen
PROCEDURE NZR(pD0101 IN vis_d0101%ROWTYPE, pD0101_3 IN vis_d0101%ROWTYPE) AS 
  vCnt INT;
  vA010145_Code vis_a010145.code%TYPE;
  vGKZ2 vis_s00.gkz2%TYPE;
  
  -- NRZ Kopieren, 
  -- pCode_old, pSKZ : alte Code
  -- pCode_new : wenn nicht NULL dann mit diesem Code Anlegen, sonst bleibt der Code erhalten  
  PROCEDURE KopieNRZ(pCode_old IN VARCHAR2, pSKZ IN INT, pCode_new IN VARCHAR2) AS 
  TYPE tbD010102 IS TABLE OF vis_d010102%ROWTYPE;
  vD010102 tbD010102 := tbD010102();
  vA010145_SID vis_a010145.sid%TYPE;
  vA010145_BEZ vis_a010145.bez%TYPE;
  BEGIN
  
    SELECT d010102.* BULK COLLECT INTO vD010102
    FROM vis_d010102 d010102
    JOIN vis_a010145 a010145 ON a010145.sid = D010102.a010145_SID
    AND a010145.skz = pSKZ
    AND a010145.code = pCode_old
    AND d010102.d0101_id = pD0101.id
    AND d010102.deleted = 0
    AND d010102.deleted > -2;
    
    IF vD010102.COUNT > 0 THEN -- HIT-Nr. vorhanden    
    
      IF pCode_New IS NOT NULL THEN 
        SELECT sid, bez INTO vA010145_SID, vA010145_bez 
        FROM vis_a010145
        WHERE code = pCode_New
        AND deleted > -2
        AND skz = pSKZ;
      END IF;
      
      FOR i IN vD010102.FIRST .. vD010102.LAST LOOP
        vD010102(i).id := SYS_GUID;
        IF pCode_New IS NOT NULL THEN
          vD010102(i).a010145_SID := vA010145_SID;
          vD010102(i).bez := vA010145_bez;
        END IF;
        vD010102(i).ins_date := SYSDATE;
        vD010102(i).upd_date := SYSDATE;
        vD010102(i).ins_user := vUser_SID;
        vD010102(i).upd_user := vUser_SID;
        vD010102(i).d0101_id := pD0101_3.id;
        vD010102(i).d010101_id := '-1';  
        /*vD010102(i).gueltig_von := NULL;      
        vD010102(i).gueltig_bis := NULL; 
        vD010102(i).ruht_von := NULL; 
        vD010102(i).ruht_bis := NULL; 
        vD010102(i).ruht_jn := 0; 
        vD010102(i).wiederruf_am := NULL;*/
        vD010102(i).d0302_id := '-1';    
      END LOOP; 
      
      FORALL i IN INDICES OF vD010102
        INSERT INTO vis_d010102 VALUES vD010102(i);

      $IF $$BLV_DEBUG $THEN
      $ELSE 
        COMMIT;
      $END
          
    END IF;  
  
  END KopieNRZ;
  
BEGIN
  SELECT
  CASE WHEN s00.Gkz2 = vGKZ2_NRW THEN vBetreiber_ID ELSE '0103' END
  , s00.gkz2
  INTO vA010145_Code, vGKZ2
  FROM vis_s00 s00
  WHERE s00.sid = 1;
  -- Prfung HIT-Schnittstelle vorhanden - todo
  
  -- Betreiber-ID bei Betrieb vorhanden -> zum Betreiber verschieben
  UPDATE (
    SELECT d010102.d0101_id, d010102.upd_date, d010102.upd_user
    FROM vis_d010102 d010102
    JOIN vis_a010145 a010145 ON a010145.sid = d010102.a010145_sid
    AND a010145.code = vA010145_Code  -- IDV-Betreiber ID
    AND a010145.skz = 10
    AND a010145.deleted > -2
    AND d010102.deleted = 0
    AND d010102.d0101_id = pD0101.id )
  SET d0101_id = pD0101_3.id
  , upd_date = SYSDATE
  , upd_user = vUser_sid;  
  
  vCnt := SQL%ROWCOUNT;
  
  IF vCnt = 0 AND vGKZ2 <> vGKZ2_NRW THEN -- keine Betreiber-ID verschoben  
    -- nicht fr NRW - HIT-Nr. bei Betrieb vorh. -> daraus Betreiber-ID fr Betreiber erzeugen     
    KopieNRZ(vHIT_NR, 10, vA010145_Code);
  END IF;
  -- Invekos auf Betreiber kopieren
  KopieNRZ(vInvekos_NR, 10, NULL);    

END;

-- Betreiber anlegen
PROCEDURE SplitOperator(pD0101_ID IN vis_d0101.id%TYPE, pBatch IN INT := 0) AS
 --vD0101_d0101_id3 vis_d0101.d0101_id3%TYPE;
 vD0101_4 vis_d0101%ROWTYPE;
 v1 INT;
 vVName vis_d0101.vname%TYPE;
 vD0101 vis_d0101%ROWTYPE;
 vD0101_3 vis_d0101%ROWTYPE;
 vMsgTrigger INT := 1;
 TYPE trID IS RECORD ( id vis_d0101.id%TYPE, daten_herkunft vis_d0101.daten_herkunft%TYPE );
 TYPE tID IS TABLE OF trID;
 vD0101_IDs tID;
 --vCntBtr INTEGER := 0;
 vSYSDATE DATE := SYSDATE;
BEGIN

  SELECT d0101.* INTO vD0101
  FROM vis_d0101 d0101 
  WHERE d0101.id = pD0101_ID
  AND d0101.deleted = 0;  

  -- todo 56028090 19.11.2014
  vMandant_Sid := vD0101.Mandant;
  vUser_sid := BLV_SYS.GET_USER_SID;
      
  IF vD0101.id <> vD0101.d0101_id3 AND vD0101.d0101_id3 <> '-1' THEN
    AddRepairMsg('Die Betriebssttte hat schon einen abweichenden Betreiber. Das Trennen ist nicht notwendig.');
    vWKD_BEA.result := 1;
    vD0101 := NULL;
    --vD0101_3 := NULL;    
    RETURN;
  ELSIF vD0101.skz <> 1 THEN
    AddRepairMsg('Es knnen nur aus berwachungsrelevanten Betriebssttten Betreiber erzeugt werden.');
    vWKD_BEA.result := 1;
    vD0101 := NULL;
    --vD0101_3 := NULL;    
    RETURN;
  
  END IF;  

  vMsgTrigger := blv_sys.get_EnabledMsgTrigger();
  blv_sys.set_EnabledMsgTrigger(0); -- Meldungstrigger ausschalten
    
  --vD0101_D0101_ID3 := vD0101.d0101_id3; -- alten Betreiber fr spter merken

  vD0101_3 := vD0101;
  
  vD0101.upd_date := vSYSDATE;
  vD0101.upd_user := vUser_SID;
  vD0101.A0101_03_SID := -1;

  vD0101_3.upd_date := vSYSDATE;
  vD0101_3.upd_user := vUser_SID;
  vD0101_3.ins_date := vSYSDATE;
  vD0101_3.ins_user := vUser_SID;
  
  vD0101_3.id := SYS_GUID();
  vD0101_3.d0101_id3 := vD0101_3.id; 

  vD0101.d0101_id3 := vD0101_3.id;  
  vD0101.bez_art := 'F'; -- immer bei Betriebssttte
  vD0101.d0101_id2 := vD0101_3.id; -- Post an Betreiber    
  vD0101_3.d0101_id2 := vD0101_3.id;  
  vD0101_3.name1 := vD0101.p_name1;
  
  -- Spezialfall GmbH und Co. KG (a0101_03_sid = 5)
  IF GetRechtsformBetreiber2(vD0101_3.a0101_03_sid) > 0 THEN
    vD0101_3.betreiber_abw := 1;
  ELSE
    vD0101_3.betreiber_abw := 0;
  END IF;
  -- 20.05.2014 vD0101_3.betreiber_abw := CASE WHEN vD0101_3.a0101_03_sid = 5 THEN 1 ELSE 0 END;
  vD0101.betreiber_abw := 1;
  vD0101_3.skz := 99;
  vD0101_3.FB := '-';
  vD0101_3.fb0 := '-';
  vD0101_3.fachb := '(keine Fachbereiche)';
  vD0101_3.fachb0 := '(keine Fachbereiche)';
  vD0101_3.code := NULL;  --vD0101_3.code || '_B';
  vD0101_3.coden := NULL;
  -- 12.04.2014 vD0101.daten_herkunft := 'BEA';
  vD0101_3.daten_herkunft := 'BEA';
  
  vD0101_3.D010200_ID := -1;
  vD0101_3.A030501_01_SID := -1;
  vD0101_3.A030501_02_SID := -1;
  vD0101_3.A030502_SID := -1;
  vD0101_3.A0113_100_SID := -1;
  vD0101_3.A010108_SID := -1;
  vD0101_3.A030501_05_SID := -1;
  
  vD0101_3.d0101_ID10 := '-1';
  vD0101_3.BEM := NULL;
  vD0101_3.D0101_ID4 := '-1';
  vD0101_3.D010200_ID2 := '-1'; 
  
  vD0101_3.AMBULANT_JN := 0; -- zurcksetzen 1 wechselnder Standort, 2 freitextliche Standortbeschreibung    

  CASE
  -- keine abw. Postadresse -> Postadr. = Standortadr.
  WHEN vD0101_3.abw_post = 0 THEN
    vD0101_3.is_postfach := 0;
    vD0101_3.p_plz := vD0101.plz;
    vD0101_3.p_ort := vD0101.ort;
    vD0101_3.p_ortsteil := vD0101.ortsteil;
    vD0101_3.p_strasse := vD0101.strasse;
    vD0101_3.p_hausnr := vD0101.hausnr;
    vD0101_3.p_hausnrzusatz := vD0101.hausnrzusatz;
        
  -- Betriebssttte mit Postanschr. ohne Postfach
  -- -> Betreiber: Sitzadr. := Postadr.,,Postadr. bleibt erhalten
  WHEN vD0101_3.abw_post = 1 AND vD0101_3.is_postfach = 0 THEN 
    vD0101_3.abw_post := 0;
    vD0101_3.plz := vD0101_3.p_plz;
    vD0101_3.ort := vD0101_3.p_ort;
    vD0101_3.ortsteil := vD0101_3.p_ortsteil;
    vD0101_3.strasse := vD0101_3.p_strasse;
    vD0101_3.hausnr := vD0101_3.p_hausnr;
    vD0101_3.hausnrzusatz := vD0101_3.p_hausnrzusatz;
    vD0101_3.ambulant_jn := 0;
    vD0101_3.adresszusatz := NULL;
    -- Koordinaten lschen
    vD0101_3.rechtswert := NULL;
    vD0101_3.hochwert := NULL;    
    vD0101_3.x_wert := NULL;
    vD0101_3.y_wert := NULL;
    vD0101_3.gis_quelle := NULL;
    vD0101_3.gis_objnr := NULL;
    vD0101_3.s09_sid := -1;
    vD0101_3.FLURSTUECK := NULL;
    vD0101_3.GEMARKUNG := NULL;
    vD0101_3.FLURNUMMER := NULL;
    
  -- Betriebssttte mit Postanschr. und Postfach
  -- -> Betriebssttte: Postadr. := Postadr., Sitzadr. = Standortadr. 
  WHEN vD0101.abw_post = 1 AND vD0101.is_postfach = 1 THEN
    NULL;
  ELSE NULL;  
  END CASE;
  -- Fall Berlin: vname nname in bez enthalten 
  IF vWKD_BEA.result_msg LIKE '2.10%' OR vWKD_BEA.result_msg LIKE '2.11%' THEN
    vD0101_3.NName := TRIM( dbo.get_token(vD0101_3.bez, 1, ',') );
    vD0101_3.VName := TRIM( dbo.get_token(vD0101_3.bez, 2, ',') );
    vD0101_3.Titel := TRIM( dbo.get_token(vD0101_3.bez, 3, ',') );  
    vD0101_3.anrede := NULL;
    vVName :=  dbo.get_token(REPLACE(vD0101_3.vname, '-', ' '), 1, ' ');
    IF ChkVNamen( vVName ) = 1 THEN -- gltige Vornamen -> Anrede ermitteln
      SELECT MAX(a0081.anrede) INTO vD0101_3.anrede
      FROM vis_a0081 a0081
      WHERE a0081.vname = vVName;
    END IF;    
  END IF;
  
  INSERT INTO vis_d0101 VALUES vD0101_3;
  $IF $$BLV_DEBUG $THEN
  $ELSE 
    COMMIT;
  $END

  UPDATE vis_d0101 
  SET ROW = vD0101
  WHERE id = vD0101.id;  
  
  -- Personal ------------------------------------------------------------------
  IF vWKD_BEA.result_msg LIKE '2.10%' OR vWKD_BEA.result_msg LIKE '2.11%' THEN
    -- Fall Berlin
    Personal_N(vD0101, vD0101_3, 1);
  ELSE
    CASE GetRechtsformTyp( vD0101_3.a0101_03_sid ) 
    WHEN 'N' THEN -- Einzelunternehmen
      Personal_N(vD0101, vD0101_3, 0); 
    WHEN 'E' THEN -- keine Rechtsform
      Personal_N(vD0101, vD0101_3, 0); 
    WHEN 'F' THEN -- Firma
      Personal_F(vD0101, vD0101_3) ; 
    ELSE  -- keine Rechtsform
      Personal_N(vD0101, vD0101_3, 0);
    END CASE;
  END IF;
  -- HIT-Nr.
  NZR(vD0101, vD0101_3);

  -- Ttigkeiten -Betreiber aktualisieren
  IF vD0101.skz = 1 THEN
    UPDATE vis_d010801
    SET d0101_id4 = vD0101_3.ID
      , upd_date = vSYSDATE
      , upd_user = vUser_sid
    WHERE d0101_id = vD0101.id
    AND d0101_id4 = d0101_id;
  END IF;
    
  -- Spezialfall Hauptbetrieb 
  -- bei allen Betrieben wo der Hauptbetrieb als Betreiber eingetragen ist den neuen Betreiber zuordnen
  --22.10.2014IF vD0101_D0101_ID3 <> '-1' THEN
    UPDATE vis_d0101
    SET d0101_id3 = vD0101_3.id
      , d0101_id2 = vD0101_3.id
      , upd_date = vSYSDATE
      , upd_user = vUser_SID    
    WHERE d0101_id3 = vD0101.ID  --22.10.2014 vD0101_D0101_ID3
    AND deleted = 0
    RETURNING id, daten_herkunft BULK COLLECT INTO vD0101_IDs;
    
    --IF SQL%ROWCOUNT > 0 AND pBatch = 1 THEN 21.10.2014
    IF vD0101_IDs.COUNT > 0 AND pBatch = 1 THEN
      FORALL i IN vD0101_IDs.FIRST .. vD0101_IDs.LAST
        UPDATE vis_d0101
        SET bez = vD0101_3.bez
          , p_name = vD0101_3.p_name
          , upd_date = vSYSDATE
          , upd_user = vUser_SID
          , HIT_BEZ_1 = vD0101_3.HIT_BEZ_1
          , HIT_BEZ_2 = vD0101_3.HIT_BEZ_2
        WHERE -- 22.10.2014 d0101_id3 = vD0101_3.id
          id = vD0101_IDs(i).id
        --22.10.2014 AND deleted = 0
        AND skz = 1 -- 12.05.2014 in Absprache mit DD - Betreiber drfen nicht angepasst werden
        AND daten_herkunft = 'BEA';
      --END LOOP;
    END IF;    
    
    -- 21.10.2014 todo 55758090 - Neue Analyse der Betriebssttten
    IF vD0101_IDs.COUNT > 0 THEN
      FOR i IN vD0101_IDs.FIRST .. vD0101_IDs.LAST LOOP
        IF vD0101_IDs(i).id <> vD0101.ID AND NVL(vD0101_IDs(i).daten_herkunft, 'x') <> 'BEA' THEN
          IF CheckD0101(vD0101_IDs(i).id) > 0 THEN NULL; END IF;
        END IF;
      END LOOP;
    END IF;
    
  --22.10.2014END IF;
  
  IF pBatch = 0 THEN
    UPDATE wkd_bea
    SET result = 0
      , upd_date = vSYSDATE
      , upd_user = vUser_sid
    WHERE d0101_id = vD0101.id;

    UPDATE wkd_bea
    SET result = 0
      , upd_date = vSYSDATE
      , upd_user = vUser_sid
    WHERE d0101_id = vD0101_3.id;

    IF SQL%ROWCOUNT = 0 THEN -- Betreiber in wkd_bea anlegen
      v1 := CheckD0101(vD0101_3.id, 1); -- wkd_bea nur anlegen
    END IF;
  END IF;
  
  -- Spezialfall GmbH und Co. KG (a0101_03_sid = 5
  --IF vD0101_3.a0101_03_sid = 5 THEN 
  IF vD0101_3.betreiber_abw = 1 THEN -- oben ermittelt
    vD0101_4 := vD0101_3;
    vD0101_4.ID := SYS_GUID();
    vD0101_4.D0101_ID3 := vD0101_4.ID;
    vD0101_4.betreiber_abw := 0;
    vD0101_4.A0101_03_SID := GetRechtsformBetreiber2(vD0101_3.A0101_03_SID) ; 
    
    INSERT INTO vis_d0101 VALUES vD0101_4;
    $IF $$BLV_DEBUG $THEN
    $ELSE 
      COMMIT;
    $END
    
    UPDATE vis_d0101
    SET d0101_id3 = vD0101_4.ID
      , upd_date = vSYSDATE
      , upd_user = vUser_SID
    WHERE id = vD0101_3.ID;
    
    vD0101_4 := NULL;
    
  END IF;

  blv_sys.set_EnabledMsgTrigger(vMsgTrigger); -- alter Stand Meldungstrigger herstellen
  vD0101 := NULL;
  vD0101_3 := NULL;
  
END;

FUNCTION Version RETURN VARCHAR2 AS
BEGIN
  RETURN '1.23.000';
END;

BEGIN
  NULL;    
END;
/

